#!/usr/bin/perl
# comparateur.pl

<<DOC;
Cyril Grouin - Sat Apr 21 15:43:59 2001

	comparateur.pl

Format d'entre :
_ les fichiers de rfrence d'extension ".reference"
_ et les fichiers  valuer d'extension ".decanteur"

Format de Sortie :
  Comparaison
   de   C:\TypWeb\CorpusManuel\Sorties\*.reference
   avec C:\TypWeb\EchantillonAu100Eme\Sorties\*.decanteur
   le   Sun Apr 22 15:20:43 2001

  Reponses correctes  = 885
  Reponses manquantes = 95
  Bruit               = 30
  Reponses totales    = 980

  Precision = 0.97
  Rappel    = 0.90
  Score F1  = 0.93
  Score F2  = 0.92
  Mesure-G  = 0.87

A faire :

Bugs et problmes :
_ compare les lignes d'introduction alors qu'il n'y a pas lieu d'tre :
DEC : <source>...</source><date>Sat Apr 21 15:59:48 2001</date>
REF : <source>...</source><date>Fri Mar 30 13:05:46 2001</date>
21/04/01> problme rsolu en ignorant ces lignes.
_ problmes dans les formules du rappel et de la prcision > rsolu.

Commande : perl comparateur.pl C:\TypWeb\CorpusManuel\Sorties\ C:\TypWeb\EchantillonAu100Eme\Sorties\

Infos :
_ http://grouin.free.fr/maitrise/memoire/scripts/

DOC

# Fonction Debuggage : "o" pour oui, "n" pour non.
$Debug="n";

# Ligne d'aide en cas d'erreur
$ChaineUsage="Usage : comparateur.pl <chemin corpus reference> <chemin corpus a evaluer>\nAttention : terminer chaque chemin par un back-slash \"\\\"\n";
if (@ARGV!=2) {
 die $ChaineUsage;
}

# Lecture des arguments : chemin des fichiers de rfrence
# et chemin des fichiers  valuer
$CheminCorpusReference=$ARGV[0];
$CheminCorpusAEvaluer=$ARGV[1];
%Reference=();
%Evaluation=();
# Fichier qui va contenir les rsultats
$FichierResultats=">Resultats.txt";
open(Result,$FichierResultats);
print Result "Comparaison\n de   $CheminCorpusReference*.reference\n avec $CheminCorpusAEvaluer*.decanteur\n le   ";
print Result scalar (localtime);
print Result "\n\n";
# Fichiers qui vont contenir le bruit et les manques
$FB=">Bruit.txt";
open(Bruit,$FB);
$FM=">Silence.txt";
open(Manque,$FM);

if ($Debug eq "o") {
 # Fichier qui va contenir les noms des fichiers de rfrences et  valuer
 $FichierSortie=">Comparaison.txt";
 open(Sortie,$FichierSortie);
 # Fichier qui va contenir toutes les lignes des fichiers de rfrence
 $AA=">Ref.txt";
 open(FRef,$AA);
 # Fichier qui va contenir toutes les lignes des fichiers  valuer
 $BB=">Eva.txt";
 open(FEva,$BB);
}

# Parcours du dossier contenant les fichiers de rfrence
while ($FichRef=<$CheminCorpusReference*.reference>) {
 # Si le fichier trouv est d'extension ".reference"
 if ($Debug eq "o") {
  # Impression du nom de ce fichier sur le fichier Comparaison.txt
  print Sortie "$FichRef\n";
 }
 open(Ref,"<$FichRef");
 # Mmorisation de chaque ligne dans le tableau de hachage %Reference
 while ($Ligne=<Ref>) {
  if ($Ligne =~ /^(<.+>)$/) {
   if ($Ligne =~ /^<source>/) {
    # Non prise en considration de ce type de ligne
   }
   else {
    if ($Debug eq "o") { print FRef "$Ligne\n"; }
    $Reference{$Ligne}++;
   }
  }
 }
 close(Ref);
}

if ($Debug eq "o") {
 # Une ligne de sparartion sur le fichier Comparaison.txt
 print Sortie "-----------------------------------------------------------------------\n";
}

# Parcours du dossier contenant les fichiers  valuer
while ($FichEva=<$CheminCorpusAEvaluer*.decanteur>) {
 # Si le fichier trouv est d'extension ".decanteur"
 if ($Debug eq "o") {
  # Impression du nom de ce fichier sur le fichier Comparaison.txt
  print Sortie "$FichEva\n";
 }
 open(Eva,"<$FichEva");
 # Mmorisation de chaque ligne dans le tableau de hachage %Evaluation
 while ($Ligne=<Eva>) {
  if ($Ligne =~ /^(<.+>)$/) {
   if ($Ligne =~ /^<source>/) {
    # Non prise en considration de ce type de ligne
   }
   else {
    if ($Debug eq "o") { print FEva "$Ligne\n"; }
    $Evaluation{$Ligne}++;
   }
  }
 }
 close(Eva);
}

# Les deux tableaux de hachages %Reference et %Evaluation sont remplis.
# Il faut maintenant les comparer, de la manire suivante :
# ----- 1ere tape -----
# Pour chaque lment du tableau %Reference,
# On le cherche dans le tableau %Evaluation.
# Si on le trouve avec le mme nombre d'lments
#  -> l'indice $ok est incrment du nombre d'lments
#     et limination de l'lment de %Evaluation
# Si on le trouve avec moins d'lments dans %Evaluation que dans %Reference
#  -> l'indice $mq est incrment du nombre d'lments qui manquent,
#     $ok du nombre d'lments restant,
#     et limination de l'lment dans %Evaluation.
# Si l'lment n'est pas trouv,
#  -> augmentation de l'indice $mq du nombre d'lements manquants.
# ----- 2eme tape -----
# Pour chaque lment du tableau %Evaluation,
#  -> l'indice $bruit augmente du nombre d'lments  chaque fois.
# Nous disposons maintenant de trois indices :
# _ $ok qui indique le nombre de rponses correctes partages
# _ $mq qui indique le nombre de rponses non extraites
# _ $bruit qui indique le nombre de rponses extraites en trop
# Le nombre de rponses total qu'il fallait extraire est : $ok + $mq.

# 1ere tape : parcours %Reference
while (($Ligne,$Valeur)=each(%Reference)) {
 $Nb=$Evaluation{$Ligne};
 # Si mme nombre d'lments, incrmentation proportionnelle de $ok
 # et limination dudit lment dans %Evaluation
 if ($Valeur==$Nb) {
  $ok+=$Valeur; 
  $Evaluation{$Ligne}=0;
  if ($Debug eq "o") { print "OK $ok\n"; }
 }
 # Sinon considration des lments partags et ceux manquants
 else {
  $Difference=$Valeur-$Nb;
  # Icrmentation proportionnelle du nombre d'lments partags
  $ok+=$Nb;
  if ($Debug eq "o") { print "OK $ok\n"; }
  # Icrmentation proportionnelle du nombre d'lments manquants
  $mq+=$Difference;
  if ($Debug eq "o") { print "MQ $mq\n"; }
  print Manque "$Difference fois : $Ligne";
  # Puis limination dudit lment dans %Evaluation
  $Evaluation{$Ligne}=0;
 }
}
# 2eme tape : parcours %Evaluation : calcul du bruit
while (($Ligne,$Valeur)=each(%Evaluation)) {
 if ($Valeur!=0) {
  $bruit+=$Valeur;
  if ($Debug eq "o") { print "BR $bruit\n"; }
  print Bruit "$Valeur fois : $Ligne";
 }
}

# Affichage des rsultats et des calculs
print Result "Reponses correctes = $ok\n";
print Result "Silence            = $mq\n";
print Result "Bruit              = $bruit\n";
$Total=$ok+$mq;
print Result "Reponses totales   = $Total\n\n";
$Rappel=$ok/($mq+$ok);
$Precision=$ok/($ok+$bruit);
$F1Mesure=(2*$Precision*$Rappel)/($Precision+$Rappel);
$F2Mesure=(5*$Precision*$Rappel)/((4*$Precision)+$Rappel);
$MesureG=1-(($mq+$bruit)/($mq+$ok));
printf Result "Precision = %1.2f\n",$Precision;
printf Result "Rappel    = %1.2f\n",$Rappel;
printf Result "Score F1  = %1.2f\n",$F1Mesure;
printf Result "Score F2  = %1.2f\n",$F2Mesure;
printf Result "Mesure-G  = %1.2f\n",$MesureG;

# Fermeture des fichiers de rsultats, du bruit et des manques
close(Result);
close(Bruit);
close(Manque);

if ($Debug eq "o") {
 # Fermeture des fichiers
 close(FRef);
 close(FEva);
 close(Sortie);
}
