#!/usr/bin/perl
##############################################################################
#AUTHORS: 	Fleury Serge
#VERSION: 	1.0.2
#email:		serge.fleury@univ-paris3.fr
#url:		http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/mkcorpusProject.htm
#date:		June/2002
#FILE:
#    This file is part of MKCorpus.
##############################################################################
#
# [mkcorpus] Startup-code
=head1 NAME

B<mkCorpus> - Outils d'dition et de manipulation de corpus baliss (SGML, XML, HTML)
pour leurs prparations aux outils du TAL tels Lexico, Alceste, Cordial etc.
Voir documentation en ligne :
http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/mkcorpusProject.htm

=head1 SYNOPSIS

loadMkCorpus.pl
ou
win32MkCorpus.pl

=cut

my $Usage;
{
	my($prog) = ($0 =~ m#([^/]+)$#);
	my $space = " " x length $prog;
	($Usage = <<EOF) =~ s/^\t\t//gm;
		Usage: $prog 

		Use ``perldoc $prog'' for more information.
EOF
}

=head1 DESCRIPTION

voir le fichier Doc/mkcorpusdoc.PDF

=head1 AUTHOR

Fleury Serge
ILPGA / Sorbonne nouvelle - Paris 3
19 rue des Bernardins 75005 Paris
Tl. : (33/0)1.44.32.05.84
Fax : (33/0)1.44.32.05.73
Email: fleury\@msh-paris.fr ou serge.fleury\@univ-paris3.fr
Hypertoile TAL-Paris 3 ILPGA : http://www.cavi.univ-paris3.fr/ilpga/ilpga/tal/
Hypertoile SFWeb : http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/


=cut

use strict;


#-------------
# Private vars

my $mkCorpusPath;

#---------------
# Initialisation

$mkCorpusPath = &GetCWD;

#---------
# MainLoop

use Tk 800.022;
#use Tk::ErrorDialog;
use winMain;

# Dialogs+Tk
CreateWinMain();
MainLoop();

#---------
#GetCWD

sub GetCWD {

  # -- GetCWD
  # Get the current working directory, make sure it ends with a slash
  # No parameters
  # Returns cwd
  # reach the mount point on a Windows machine)

  use Cwd;
  my $dir;

  $dir = getcwd;
  # method from Cwd.pm
  $dir =~ s/\n//g;
  if ($dir !~ m#/$#) {
    $dir = "$dir/";
  }

  return $dir;

}  # GetCWD


