package winFunc2;
##############################################################################
#AUTHORS: 	Fleury Serge
#VERSION: 	1.0.2
#email:		serge.fleury@univ-paris3.fr
#url:		http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/mkcorpusProject.htm
#date:		June/2002
#FILE:
#    This file is part of MKCorpus.
##############################################################################
#
# winFunc2.pm
#
# [mkcorpus] Callback-functions for all windows
#

#-------
# Export

use strict;
use Exporter;
use vars qw(@ISA @EXPORT 
);
@ISA = qw(Exporter);
@EXPORT = qw( &loadCube $leftview $rightview $leftviewSearchStr $rightviewSearchStr $mkckub
	     );


#-------
# Packages

use Tk 800.022;
use Tk::TextUndo;
use Tk::TextEdit;
use Tk::TextTools;
use Tk::MarkupTools;

use Tk::Menu;
use Tk::Optionmenu;
use Tk::Photo;
use Tk::Balloon;
use Tk::CheckButton;
use Tk::RadioButton;

use Tk::Balloon;
use Tk::ObjScanner;
use Tk::DirTree;
use Tk::WaitBox;
use Tk::ProgressBar;
use Tk::Date;
use Tk::XMLViewer;
use Tk::Animation;
use Tk::Dialog;
use Tk::DialogBox;
use Tk::Toplevel;
use Tk::FileSelect;

use English;
use File::Basename;
use Data::Dumper;

use winMain;
use winFunc1;

use IO::Handle;
use IO::Seekable;
use IO::File;
use IO::Pipe;
use IO::Socket;
use IO::Dir;


#-----------------
# Global variables

#------------------
# Private Variables

my $mkckub;
my $top1;
my $top2;
my $top3;
my $top4;
my $top5;
my $pn9;
my $pnDraw;

my $leftviewSearchStr;
my $rightviewSearchStr;
my $leftview;
my $rightview;
my $texteMp;
my %mapTextFull;
my %mapTextFull2;
my $id;
my $canvas;
my $id;
my $markname;
my @color;
my $search_string_map;
my %listeNodes2Map;
my %listeNodes2Map1;

my $listePnXMLBalise;
my $pnXMLBalise;
my @listesTagForView;
my @liste_xmlBalise = ();
my %Liste_xmlBalise = ();
my @listxmlDomExtractTag=();
my %listxmlDomExtractTag=();

my @selectionParcourirDOM=();
my %selectionParcourirDOM=();


my $listePnXMLBaliseWithDOM1;

#---------------------------------------------------------------------------------------
#Procdures et premiers Niveaux
#---------------------------------------------------------------------------------------

#---------------------------------------------

sub loadCube {
    $mkckub = $winMain::mw->Toplevel( -title => "KUB-LEXICO",-background=>'#edf0f3'); 
#    $mkckub->minsize(qw(800 600)); 
#    $mkckub->maxsize(qw(800 600));

# Frames superieurs

    my $frame1 = $mkckub->Frame(-background=>'#edf0f3')->pack(-side=>'top'); 
    my $frameA = $frame1->Frame(-background=>'#edf0f3')->pack(-side=>'top', 
							      -padx=>1);
    my $frameAl = $frameA->Frame(-background=>'#edf0f3')->pack(-side=>'left', 
							      -padx=>1);
    my $frameAr = $frameA->Frame(-background=>'white')->pack(-side=>'right', 
							      -padx=>1);
    my $frameA1 = $frame1->Frame(-background=>'yellow')->pack(-side=>'top', 
							       -padx=>1);
    my $frameA2 = $frame1->Frame(-background=>'white')->pack(-side=>'bottom', 
							       -padx=>1);
    my $frameA2a = $frameA2->Frame(-background=>'black')->pack(-side=>'left', 
							       -padx=>1);
    my $frameA2b = $frameA2->Frame(-background=>'blue')->pack(-side=>'right', 
							       -padx=>1);

#--------------------Balloonmessages------------------------
    my $winBalloon = $frame1->Balloon(
				       -initwait => 400,
				       -state => 'balloon'
				       );

#---------
    my $logo=$frameAl->Photo(-file=> "pics/cube.gif");
    $frameAl->Label(-image => $logo)->pack(-side => 'left');
    $frameAl->Label(-text=>"MKCORPUS-Lekub2Lexico", 
		   -font=>"{Verdana} 16 {bold}", 
		   -background=>'#edf0f3')->pack(-side=>'left',
					      -padx=>2,
					      -pady=>2);
    $frameAl->Label(-image => $logo)->pack(-side => 'right');
   
    my $time;
    my $date = $frameAr->Date(-editable => 0,
				-variable => \$time,
				-value => 'now',
				)->pack(-side => 'left');
    $date->repeat(999, sub { $time = time(); });
    $frameAr->Label(-image => $logo)->pack(-side => 'right');
    my $running;
    my $camel=$frameAr->Animation('-format' => 'gif',
			     -file => Tk->findINC('anim.gif'));
    my $l = $frameAr->Label(-image => $camel)->pack(-side => 'right');
    $frameAr->Button(-text => 'Start/Stop',
		       -command => sub {
			   if (!$running) {
			       $camel->start_animation(80);
			   } else {
			       $camel->stop_animation();
		 }
			   $running = !$running;
		       })->pack(-side => 'right');
   
    

#---------------------------------------------
    my $imageedxml = $mkckub->Photo(-file => "pics/plan.gif");
    my $butonLoad=$frameA1->Button (-text=>"LoadTree",
				    -image => $imageedxml,
				    -font=>"{Verdana} 10 {bold}",
				    -background=>'#0a3650',
				    -activebackground=> 'black',
				    -foreground=> '#eff3a5',
				    -activeforeground=> '#eff3a5',
				    -command=> sub {&loadTree},
				    -relief=>'raised' )-> pack (-side=>'left',
								-expand=>1,
								-padx=>2,
								-pady=>2);
    
    $winBalloon->attach($butonLoad,
                 -balloonmsg => "LoadTree");

   my $butonCanvas=$frameA1->Button (-text=>"Zoom",
				    -font=>"{Verdana} 10 {bold}",
				    -background=>'#0a3650',
				    -activebackground=> 'black',
				    -foreground=> '#eff3a5',
				    -activeforeground=> '#eff3a5',
				    -command=> sub {&loadZoom},
				    -relief=>'raised' )-> pack (-side=>'left',
								-expand=>1,
								-padx=>2,
								-pady=>2);
   my $butonCanvas=$frameA1->Button (-text=>"Tree",
				    -font=>"{Verdana} 10 {bold}",
				    -background=>'#0a3650',
				    -activebackground=> 'black',
				    -foreground=> '#eff3a5',
				    -activeforeground=> '#eff3a5',
				    -command=> sub {&parcoursDomTree},
				    -relief=>'raised' )-> pack (-side=>'left',
								-expand=>1,
								-padx=>2,
								-pady=>2);

    my $butonClose=$frameA1->Button (-text=>"Close",
				    -font=>"{Verdana} 10 {bold}",
				    -background=>'#0a3650',
				    -activebackground=> 'black',
				    -foreground=> '#eff3a5',
				    -activeforeground=> '#eff3a5',
				    -command=> sub {$mkckub->destroy();},
				    -relief=>'raised' )-> pack (-side=>'left',
								-expand=>1,
								-padx=>2,
								-pady=>2);
    


#---------------------------------------------
# Frame infrieurs plus constituants
#---------------------------------------------

    my $frameA2bh = $frameA2b->Frame(-background=>'white')->pack(-side=>'top', 
								   -padx=>1);
    my $frameA2bb = $frameA2b->Frame(-background=>'white')->pack(-side=>'bottom', 
								    -padx=>1,-padx=>2);
    my $zoneSearchA2b = $frameA2bh->Frame(-background=>'white')->pack(-side=>'top',
									-padx=>1);
    my $zoneButtA2b = $frameA2bh->Frame(-background=>'white')->pack(-side=>'top',
									-padx=>1);
    
    my $frameA2ah = $frameA2a->Frame(-background=>'white')->pack(-side=>'top', 
								   -padx=>1);
    my $frameA2ab = $frameA2a->Frame(-background=>'white')->pack(-side=>'bottom', 
								   -padx=>1,-padx=>2);
    my $zoneSearchA2a = $frameA2ah->Frame(-background=>'white')->pack(-side=>'top',
									-padx=>1);
    my $zoneButtA2a = $frameA2ah->Frame(-background=>'white')->pack(-side=>'top',
									-padx=>1);

#---------------------------------------------
    $leftview = $frameA2ab->Scrolled(qw/Text -setgrid true -width 60 -height 24  -scrollbars e -wrap word/, -font => "{Verdana} 8")->pack(qw/-expand yes -fill both/);	    
    $rightview = $frameA2bb->Scrolled(qw/Text -setgrid true -width 60 -height 24  -scrollbars e -wrap word/, -font => "{Verdana} 8")->pack(qw/-expand yes -fill both/);							

# Pb avec MarkupTools a verifier
#    $leftview = $frameA2ab->Scrolled( 'MarkupTools', 
#				      -scrollbars => 'ose',
#				      -exportselection => 'true',
#				      -selectforeground => 'white',
#				      -selectbackground => "#000070669645",
#				      -width  =>  60 ,
#				      -height  =>  24,
#				      -insertwidth => 3, 
#				      -setgrid => 'true',
#                                     -wrap => 'word'  )->pack( -side => 'top', -fill => 'both', -expand => 1 );

#    $rightview = $frameA2bb->Scrolled( 'MarkupTools', 
#				       -scrollbars => 'ose',
#				       -exportselection => 'true',
#				       -selectforeground => 'white',
#				       -selectbackground => "#000070669645",
#				       -width  =>  60 ,
#				       -height  =>  24,
#				       -insertwidth => 3,
#				       -setgrid => 'true',
#				       -wrap => 'word'  )->pack( -side => 'top', -fill => 'both', -expand => 1 );

#--------------------Rechercher mot et zone de saisie gauche ----------
    $zoneSearchA2a->Label(-text=>"Search :",
			  -font=>"{Verdana} 9 {bold}",
			  -background=>'red')->pack(-side=>'left',
						    -padx=>2,
						    -pady=>1);    
    my $image=$zoneSearchA2a->Photo(-file=> "pics/kubsearch.gif");
    
    my $butonsearch = $zoneSearchA2a->Button(-image=>$image,
			      -font=>"{Verdana} 8 {bold}",
			      -background=>'#0a3650',
			      -activebackground=> 'black',
			      -foreground=> '#eff3a5',
			      -activeforeground=> '#eff3a5',
			      -relief => "raised")-> pack(-side=>'right',
							  -expand=>1,
							  -padx=>1,
							  -pady=>2);
    $butonsearch->configure(-command => [sub {&loadSearchLeft;}]);
    $winBalloon->attach($butonsearch,
			-balloonmsg => "Search");		   
    my $recherche1 = $zoneSearchA2a->Entry(-relief=>'sunken',
				      -textvariable=>\$leftviewSearchStr)->pack(-side=>'right',
										-padx=>10,
										-pady=>20);
    my $butonTexte=$zoneButtA2a->Button (-text=>"View",
				    -font=>"{Verdana} 8 {bold}",
				    -background=>'#0a3650',
				    -activebackground=> 'black',
				    -foreground=> '#eff3a5',
				    -activeforeground=> '#eff3a5',
				    -command=> sub {&mkSelectionXMLMarkupLeft},
				    -relief=>'raised' )-> pack (-side=>'left',
								-expand=>1,
								-padx=>2,
								-pady=>2);
    
    $winBalloon->attach($butonTexte,
                 -balloonmsg => "Select-view");
        
    my $surligner=$zoneButtA2a->Button(-text => "HighLight",
				  -font=>"{Verdana} 8 {bold}",
				  -background=>'#0a3650',
				  -activebackground=> 'black',
				  -foreground=> '#eff3a5',
				  -activeforeground=> '#eff3a5',
				  -command => sub {&loadSearchLeft;},
				  -relief => "raised")-> pack(-side=>'left',
							      -expand=>1,
							      -fill=>'x',
							      -padx=>20,
							      -pady=>20);
    $winBalloon->attach($surligner,
			-balloonmsg => "HighLight" );
    my $annul=$zoneButtA2a->Button (-text=>"NoHighLight",
			   -font=>"{Verdana} 8 {bold}",
			   -command=>sub {&remove_mark_search_left},
			   -relief=>'raised',
			   -background=>'#0a3650',
			   -activebackground=> 'black',
			   -foreground=> '#eff3a5',
			   -activeforeground=> '#eff3a5') -> pack (-side=>'left',
								   -expand=>1,
								   -padx=>1,
								   -pady=>1);
    
    $winBalloon->attach($annul,
			-balloonmsg => "No HighLight" );
    
    
#--------------------Rechercher mot et zone de saisie droite ----------
    $zoneSearchA2b->Label(-text=>"Search :",
		-font=>"{Verdana} 9 {bold}",
		-background=>'red')->pack(-side=>'left',
					      -padx=>2,
					      -pady=>1);    
    my $image2=$zoneSearchA2b->Photo(-file=> "pics/kubsearch.gif");
    
    my $butonsearch2 = $zoneSearchA2b->Button(-image=>$image2,
			      -font=>"{Verdana} 8 {bold}",
			      -background=>'#0a3650',
			      -activebackground=> 'black',
			      -foreground=> '#eff3a5',
			      -activeforeground=> '#eff3a5',
			      -relief => "raised")-> pack(-side=>'right',
							  -expand=>1,
							  -padx=>1,
							  -pady=>2);
    $butonsearch2->configure(-command => [sub {&loadSearchRight}]);
    $winBalloon->attach($butonsearch2,
			-balloonmsg => "Search");		   
    my $recherche2 = $zoneSearchA2b->Entry(-relief=>'sunken',
				      -textvariable=>\$rightviewSearchStr)->pack(-side=>'right',
									-padx=>10,
									-pady=>20);
    my $butonTexte2=$zoneButtA2b->Button (-text=>"View",
				    -font=>"{Verdana} 8 {bold}",
				    -background=>'#0a3650',
				    -activebackground=> 'black',
				    -foreground=> '#eff3a5',
				    -activeforeground=> '#eff3a5',
				    -command=> sub {&mkSelectionXMLMarkupRight},
				    -relief=>'raised' )-> pack (-side=>'left',
								-expand=>1,
								-padx=>2,
								-pady=>2);
    
    $winBalloon->attach($butonTexte2,
                 -balloonmsg => "Select-view");
        
    my $surligner2=$zoneButtA2b->Button(-text => "HighLight",
				  -font=>"{Verdana} 8 {bold}",
				  -background=>'#0a3650',
				  -activebackground=> 'black',
				  -foreground=> '#eff3a5',
				  -activeforeground=> '#eff3a5',
				  -command => sub {&loadSearchRight;},
				  -relief => "raised")-> pack(-side=>'left',
							      -expand=>1,
							      -fill=>'x',
							      -padx=>20,
							      -pady=>20);
    $winBalloon->attach($surligner2,
			-balloonmsg => "HighLight" );
    my $annul2=$zoneButtA2b->Button (-text=>"NoHighLight",
			   -font=>"{Verdana} 8 {bold}",
			   -command=>sub {&remove_mark_search_right},
			   -relief=>'raised',
			   -background=>'#0a3650',
			   -activebackground=> 'black',
			   -foreground=> '#eff3a5',
			   -activeforeground=> '#eff3a5') -> pack (-side=>'left',
								   -expand=>1,
								   -padx=>1,
								   -pady=>1);
    
    $winBalloon->attach($annul2,
			-balloonmsg => "No HighLight" );
    
    &xmlMkListBalise;
    &loadView_left("forme");
    &loadView_right("categorie");
    my $msg="Chargement termin : \nLa vue gauche contient les formes graphiques du texte contenues dans un noeud XML nomm forme.\nLa vue droite contient les catgories morpho-syntaxiques associes aux formes contenues dans un noeud XML nomme categorie.\n";
    &winFunc1::mkPrintMsgInfo($msg);


#-----------------------------------------------------------------------------
# end loadCube
}

#------------Subs: open file, exit, save, searchquery, load etc.-------    
sub loadTree {
    &winFunc1::maketreetagmap;
}
#-----------------------------------------------------------------------------
sub xmlMkListBalise {
    my $parser = new XML::Parser(Style=>'Subs', Pkg=>'SubHandlers', ErrorContext => 2);
    $parser->setHandlers(End => \&end_handler,
			 Start => \&start_handler);
    @liste_xmlBalise = ();
    %Liste_xmlBalise = ();
    eval { $parser->parsefile($winMain::nom_fic)};
    if ($@) {
	&winFunc1::mkPrintErreur("Caught Error : $@\n");
	}

    sub start_handler {
	my $expat=shift;
	my $element=shift;
	if (!exists ($Liste_xmlBalise{$element})) {
	    $Liste_xmlBalise{$element}=1;
	    push (@liste_xmlBalise, $element);
	}
    }
    sub end_handler {
	my $expat = shift; my $element = shift;
    }

}
#-----------------------------------------------------------------------------
sub mkSelectionXMLMarkupRight {
    if (! Exists ($pnXMLBalise)) {
	$pnXMLBalise = $winMain::mw ->Toplevel();
	$pnXMLBalise->title("Choose Markups (Handlers) ");

	$listePnXMLBalise=$pnXMLBalise->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnXMLBalise->Button(-text => "Load View",
		     -command =>  \&loadRight)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pnXMLBalise->Button(-text => "Close",
		     -command =>  sub {$pnXMLBalise->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_balises=@liste_xmlBalise;

	$listePnXMLBalise->delete(0,'end');
	$listePnXMLBalise->insert('end',@liste_balises);

    }
    else {
	$pnXMLBalise->deiconify();
	$pnXMLBalise->raise();
    }

}
sub mkSelectionXMLMarkupLeft {
    if (! Exists ($pnXMLBalise)) {
	$pnXMLBalise = $winMain::mw ->Toplevel();
	$pnXMLBalise->title("Choose Markups (Handlers) ");

	$listePnXMLBalise=$pnXMLBalise->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnXMLBalise->Button(-text => "Load View",
		     -command =>  \&loadLeft)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pnXMLBalise->Button(-text => "Close",
		     -command =>  sub {$pnXMLBalise->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_balises=@liste_xmlBalise;

	$listePnXMLBalise->delete(0,'end');
	$listePnXMLBalise->insert('end',@liste_balises);

    }
    else {
	$pnXMLBalise->deiconify();
	$pnXMLBalise->raise();
    }

}




sub loadLeft {
    $leftview->delete("1.0","end");
    my @selection = $listePnXMLBalise->curselection();
    foreach my $ind (@selection) {
	my $element=$listePnXMLBalise->get($ind);
	use XML::XPath::XMLParser;
	my $xpp = XML::XPath::XMLParser->new( filename => $winMain::nom_fic);
	my $tree = $xpp->parse;
	my $xp = XML::XPath->new(context => $tree);
	my $nodes = $xp->find("//$element");
	foreach my $node ($nodes->get_nodelist) {
	    # get text node children as a string
	    $leftview->insert("end",$node->toString);
	    $leftview->insert("end"," ");
	}
    }
}


sub loadRight {
    $rightview->delete("1.0","end");
    my @selection = $listePnXMLBalise->curselection();
    foreach my $ind (@selection) {
	my $element=$listePnXMLBalise->get($ind);
	use XML::XPath::XMLParser;
	my $xpp = XML::XPath::XMLParser->new( filename => $winMain::nom_fic);
	my $tree = $xpp->parse;
	my $xp = XML::XPath->new(context => $tree);
	my $nodes = $xp->find("//$element");
	foreach my $node ($nodes->get_nodelist) {
	    # get text node children as a string
	    $rightview->insert("end",$node->toString);
	    $rightview->insert("end"," ");
	}
    }
}



#-----------------------------------------------------------------------------
sub loadView_left {
    my $search_string = shift;
    use XML::XPath::XMLParser;
    my $xpp = XML::XPath::XMLParser->new( filename => $winMain::nom_fic);
    my $tree = $xpp->parse;
    my $xp = XML::XPath->new(context => $tree);
    my $nodes = $xp->find("//$search_string");
    foreach my $node ($nodes->get_nodelist) {
	# get text node children as a string
	$leftview->insert("end",$node->toString);
	$leftview->insert("end"," ");
	    }
}
#-----------------------------------------------------------------------------
sub loadView_right {
    my $search_string = shift;
    use XML::XPath::XMLParser;
    my $xpp = XML::XPath::XMLParser->new( filename => $winMain::nom_fic);
    my $tree = $xpp->parse;
    my $xp = XML::XPath->new(context => $tree);
    my $nodes = $xp->find("//$search_string");
    foreach my $node ($nodes->get_nodelist) {
	# get text node children as a string
	$rightview->insert("end",$node->toString);
	$rightview->insert("end"," ");
    }
}
#-----------------------------------------------------------------------------
sub remove_mark_search_left {
    $leftview->tagDelete('leftsearch','1.0','end');
}
#-----------------------------------------------------------------------------
sub remove_mark_search_right {
    $rightview->tagDelete('rightsearch','1.0','end');
}
#-----------------------------------------------------------------------------
sub IncludedView {
    my ($view,$tmpfile,$msg) = @_;
    $view->delete("1.0","end");
    $view->insert('0.0', '');
    $view->IncludeFile($tmpfile);
}    
#-----------------------------------------------------------------------------
sub loadSearchLeft {

    &winFunc1::text_search($leftview, $leftviewSearchStr, 'leftsearch');

    if ($mkckub->depth > 1) {
	&winFunc1::text_toggle($leftview, ['configure', 'leftsearch', -background => 'SeaGreen4', -foreground => 'white'], 800,
			       ['configure', 'leftsearch', -background => undef,       -foreground => undef],   200);
    } else {
	&winFunc1::text_toggle($leftview, ['configure', 'leftsearch', -background => 'black',     -foreground => 'white'], 800,
			       ['configure', 'leftsearch', -background => undef,       -foreground => undef],   200);
    }
    
}
#-----------------------------------------------------------------------------
sub loadSearchRight {

    &winFunc1::text_search($rightview, $rightviewSearchStr, 'rightsearch');

    if ($mkckub->depth > 1) {
	&winFunc1::text_toggle($rightview, ['configure', 'rightsearch', -background => 'SeaGreen4', -foreground => 'white'], 800,
			       ['configure', 'rightsearch', -background => undef,       -foreground => undef],   200);
    } else {
	&winFunc1::text_toggle($rightview, ['configure', 'rightsearch', -background => 'black',     -foreground => 'white'], 800,
			       ['configure', 'rightsearch', -background => undef,       -foreground => undef],   200);
    }
    
}

#-----------------------------------------------------------------------------

sub loadZoom {
#sub ctext {
    # Create a window containing a canvas displaying a text string and
    # allowing the string to be edited and re-anchored.
#    use lib Tk->findINC('demos/widget_lib');
#    use Tk::widgets qw/Dialog ErrorDialog ROText/;
#    use WidgetDemo;
    my $zoom=$winMain::mw->Toplevel( -title => "KUB-ZOOM",-background=>'#edf0f3'); 
    my $TOP = $zoom->Frame()->pack;;
    my $zoomLabel=$TOP->Label(
			      -font       => "{Verdana} 7",
			      -wraplength => '5i',
			      -justify    => 'left',
			      -text     => ['You can click in the boxes to adijust the position of the text relative to its positioning point or change its justification.  The text also supports the following simple bindings for editing:
  1. You can point, click, and type.
  2. You can also select with button 1.
  3. You can copy the selection to the mouse position with button 2.
  4. Backspace and Control+h delete the selection if there is one;
     otherwise they delete the character just before the insertion cursor.
  5. Delete deletes the selection if there is one; otherwise it deletes
     the character just after the insertion cursor.']
    )->pack;

    my $c = $TOP->Scrolled(qw/Canvas -cursor crosshair -relief flat -bd 0 -width 500 -height 500/);
    $c->pack(qw/-side top -expand yes -fill both/);

    $c->create(qw/rectangle 245 195 255 205 -outline black -fill red/);

    # First, create the text item and give it bindings so it can be edited.

    my $texteFile=&extractTextForCanvas;
	
    $c->addtag(qw/text withtag/,
        $c->create('text', 450, 400,
            -text      => $texteFile,
            qw/-width 440 -anchor n -justify  left
	       -font -*-Helvetica-Medium-R-Normal--*-240-*-*-*-*-*-*/
        ),
    );
    $c->bind(qw/text <1>/ => \&ctext_press);
    $c->bind(qw/text <B1-Motion>/ => \&ctext_move);
    $c->bind(qw/text <Shift-1>/ => sub {
	my($c) = @_;
        my $e = $c->XEvent;
	my($x, $y) = ($e->x, $e->y);
	$c->select(qw/adjust current/, "\@$x,$y");
    });
    $c->bind(qw/text <Shift-B1-Motion>/ => \&ctext_move);
    $c->bind(qw/text <KeyPress>/ => sub {
	my($c) = @_;
        my $e = $c->XEvent;
	my $A = $e->A;
	$c->insert(qw/text insert/, "$A");
    });
    $c->bind(qw/text <Return>/ => sub {
	my($c) = @_;
	$c->insert(qw/text insert/, "\\n");
    });
    $c->bind(qw/text <Control-h>/ => \&ctext_bs);
    $c->bind(qw/text <BackSpace>/ => \&ctext_bs);
    $c->bind(qw/text <Delete>/ => sub {
	my($c) = @_;
	eval {local $SIG{__DIE__}; $c->dchars(qw/text sel.first sel.last/)};
	$c->dchars('text', 'insert');
    });
    $c->bind(qw/text <2>/ => sub {
	my($c) = @_;
        my $e = $c->XEvent;
	$c->insert('text', $e->xy, $winMain::mw->SelectionGet);
    });

    # Next, create some items that allow the text's anchor position to
    # be edited.

    my($x, $y, $color) = (50, 50, 'LightSkyBlue1');
    &ctext_configure ($c, $x,    $y,    -anchor => 'se',      $color);
    &ctext_configure ($c, $x+30, $y,    -anchor => 's',       $color);
    &ctext_configure ($c, $x+60, $y,    -anchor => 'sw',      $color);
    &ctext_configure ($c, $x,    $y+30, -anchor => 'e',       $color);
    &ctext_configure ($c, $x+30, $y+30, -anchor => 'center',  $color);
    &ctext_configure ($c, $x+60, $y+30, -anchor => 'w',       $color);
    &ctext_configure ($c, $x,    $y+60, -anchor => 'ne',      $color);
    &ctext_configure ($c, $x+30, $y+60, -anchor => 'n',       $color);
    &ctext_configure ($c, $x+60, $y+60, -anchor => 'nw',      $color);
    my $item = $c->create('rectangle', $x+40, $y+40, $x+50, $y+50,
			  qw/-outline black -fill red/);
    $c->bind($item, '<1>' => sub {
        shift->itemconfigure(qw/text -anchor center/);
    });
    $c->create('text', $x+45, $y-5, -text => 'Text Position', qw/-anchor s
	       -font -*-times-medium-r-normal--*-240-*-*-*-*-*-*
	       -fill brown/);

    # Lastly, create some items that allow the text's justification
    # to be changed.
    
    $x = 350; $y = 50; $color = 'SeaGreen2';
    &ctext_configure ($c, $x,    $y,    -justify => 'left',   $color);
    &ctext_configure ($c, $x+30, $y,    -justify => 'center', $color);
    &ctext_configure ($c, $x+60, $y,    -justify => 'right',  $color);
    $c->create('text', $x+45, $y-5, qw/-text Justification -anchor s
	       -font -*-times-medium-r-normal--*-240-*-*-*-*-*-*
	       -fill brown/);

    my $config_fill = '';
    $c->bind(qw/config <Enter>/ =>  [\&ctext_enter, \$config_fill]);
    $c->bind(qw/config <Leave>/ => 
        sub {$c->itemconfigure('current', -fill => $config_fill)}
    );

} # end ctext

sub extractTextForCanvas {
    my $texte;
    $texte="";
    use XML::XPath::XMLParser;
    my $xpp = XML::XPath::XMLParser->new( filename => $winMain::nom_fic);
    my $tree = $xpp->parse;
    my $xp = XML::XPath->new(context => $tree);
    my $nodes = $xp->find("//*");
    foreach my $node ($nodes->get_nodelist) {
	# get text node children as a string
	my $tmp=$node->toString;
	chomp($tmp);
	$tmp=~s/<[^>]+>//g;
	$texte.=$tmp;
	$texte.=" ";
	    }
    return $texte;
}

sub ctext_bs {

    my($c) = @_;

    eval {local $SIG{__DIE__}; $c->dchars(qw/text sel.first sel.last/)};
    my $char = $c->index(qw/text insert/) - 1;
    $c->dchars('text', $char) if $char >= 0;

} # end ctext_bs

sub ctext_configure {

    my($w, $x, $y, $option, $value, $color) = @_;

    my $item = $w->create('rectangle', $x, $y, $x+30, $y+30,
			  -outline => 'black', -fill => $color, -width => 1);
    $w->bind($item, '<1>', 
        sub {$w->itemconfigure('text', $option => $value)}
    );
    $w->addtag(qw/config withtag/, $item);

} # end ctext_configure

sub ctext_enter {

    my($w, $config_fill) = @_;

    $$config_fill =  ($w->itemconfigure('current', -fill))[4];
    $w->itemconfigure(qw/current -fill black/);

} # end ctext_enter

sub ctext_move {

    my($w) = @_;
    my $e = $w->XEvent;

    my($x, $y) = ($e->x, $e->y);
    $w->select(qw/to current/, "\@$x,$y");

} # end ctext_move

sub ctext_press {

    my($w) = @_;
    my $e = $w->XEvent;

    my($x, $y) = ($e->x, $e->y);
    $w->icursor('current', "\@$x,$y");
    $w->focus('current');
    $w->CanvasFocus;
    $w->select(qw/from current/, "\@$x,$y");

} # end ctext_press

#-----------------------------------------------------------------------------
sub parcoursDomTree {

    use XML::DOM;
#    my $file=shift;
    my $xp=new XML::DOM::Parser;
    my $doc=$xp->parsefile($winMain::nom_fic);

    if (!open(TMPDOMFILE,(">MKC-tmp_domfile.txt"))) {
	&winFunc1::mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_domfile.txt en criture\n");
	return;
    }

    &parcourir ($doc);

    print TMPDOMFILE "\n";
    close(TMPDOMFILE);
    my $tmpfile="MKC-tmp_domfile.txt";
    my $msg="MKC-tmp_domfile.txt";
    &winFunc1::IncludedFileInWindow($tmpfile,$msg);

    sub parcourir(){ my ($node)=@_;
		     my $retVal='';
		     my $numChilds=0;
		     foreach my $child ($node->getChildNodes) {
			 $numChilds++;
			 if ($child->getNodeType==ELEMENT_NODE) {
			     my $name=$child->getNodeName;
			     print TMPDOMFILE "\nNODE: $name";
			     my $attrs=$child->getAttributes;
			     foreach my $i (0..$attrs->getLength-1) {
				 my $attr=$attrs->item($i);
				 my $strAttr=$attr->getName."=".$attr->getValue;
				 print TMPDOMFILE " $strAttr";
			     }
			     my $val= &parcourir($child);
			     if (!($val eq '')) {
				 print TMPDOMFILE " VALUE=$val";
			     }
			 } elsif ($child->getNodeType==TEXT_NODE) {
			     $retVal=$child->getData();
			 }
		     }
		     if ($numChilds==1) {
			 return ($retVal);
		     } else {
			 return ('');
		     }
		 }

}


#-----------------------------------------------------------------------------



#-----------------------------------------------------------------------------



#------------------------------------------------------------------------
1;

