package winFunc3;
##############################################################################
#AUTHORS: 	Fleury Serge
#VERSION: 	1.0.2
#email:		serge.fleury@univ-paris3.fr
#url:		http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/mkcorpusProject.htm
#date:		June/2002
#FILE:
#    This file is part of MKCorpus.
##############################################################################
#
# winFunc3.pm
#
# [mkcorpus] Callback-functions for all windows
#

#-------
# Export

use strict;
use Exporter;
use vars qw(@ISA @EXPORT 
);
@ISA = qw(Exporter);
@EXPORT = qw( &loadEDXML
	     );


#-------
# Packages

use Tk 800.022;
use Tk::TextUndo;
use Tk::TextEdit;
use Tk::TextTools;
use Tk::MarkupTools;

use Tk::Menu;
use Tk::Optionmenu;
use Tk::Photo;
use Tk::Balloon;
use Tk::CheckButton;
use Tk::RadioButton;

use Tk::Balloon;
use Tk::ObjScanner;
use Tk::DirTree;
use Tk::WaitBox;
use Tk::ProgressBar;
use Tk::Date;
use Tk::XMLViewer;
use Tk::Animation;
use Tk::Dialog;
use Tk::DialogBox;
use Tk::Toplevel;
use Tk::FileSelect;

use English;
use File::Basename;
use Data::Dumper;
use winMain;

use IO::Handle;
use IO::Seekable;
use IO::File;
use IO::Pipe;
use IO::Socket;
use IO::Dir;


use FindBin qw( $Bin );

#-----------------
# Global variables

#------------------
# Private Variables

my $top1;
my $top2;
my $top3;
my $top4;
my $top5;


#---------------------------------------------------------------------------------------
#Procdures et premiers Niveaux
#---------------------------------------------------------------------------------------

#---------------------------------------------
sub loadEDXML {

my ( $matrix )    =  $winMain::mw ->Toplevel(-title => "EDXML" );
my ( $frame0 )    = $matrix->Frame();
my ( $buffer )    = $matrix->Scrolled( 'MarkupTools', -scrollbars => 'ose',
				      -exportselection => 'true',
				      -selectforeground => 'white',
				      -selectbackground => "#000070669645",
				      -insertwidth => 3, -setgrid => 'true',
				      -wrap => 'word'  );
my ( $label )     = $matrix->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
my ( $statusbar ) = $matrix->Label( -relief => 'raised' );
my ( $balloon )   = $matrix->Balloon( -statusbar => $statusbar );
my ( $menu )      = $buffer->menu( -type => 'menubar' );

my ( $toolsmenu ) = $menu->entrycget( 4, '-menu' );

my ( $frame1 )    = $frame0->Frame( -relief => 'raised', -borderwidth => 1 );
my ( $frame2 )    = $frame0->Frame( -relief => 'raised', -borderwidth => 1 );
my ( $frame3 )    = $frame0->Frame( -relief => 'raised', -borderwidth => 1 );
my ( $frame4 )    = $frame0->Frame( -relief => 'raised', -borderwidth => 1 );
my ( $frame5 )    = $frame0->Frame( -relief => 'raised', -borderwidth => 1 );
my ( $frame6 )    = $frame0->Frame( -relief => 'raised', -borderwidth => 1 );


$matrix->setPalette( "#bfbdbfbdbfbd" );
$matrix->configure( -menu => $menu );

$matrix->bind( '<F8>',        \&showParser );
$matrix->bind( '<Control-h>', \&HelpPopup  );

#$matrix->protocol( 'WM_DELETE_WINDOW' => sub { $buffer->ConfirmExit; });
#$SIG{INT} = sub {  $buffer->ConfirmExit; };


$matrix->protocol( 'WM_DELETE_WINDOW' => sub { $matrix->destroy; });
$SIG{INT} = sub {  $matrix->destroy; };


$frame1->Button( -image   => $matrix->Photo( -file =>"$Bin/ledxml/new.gif"),
		 -command => [$buffer,'ConfirmEmptyDocument'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side=>'left' );
$frame1->Button( -image => $matrix->Photo(-file =>"$Bin/ledxml/open.gif"),
		 -command => [$buffer,'FileLoadPopup'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame1->Button( -image => $matrix->Photo(-file =>"$Bin/ledxml/include.gif"),
		 -command => [$buffer,'IncludeFilePopup'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame1->Button( -image => $matrix->Photo(-file =>"$Bin/ledxml/save.gif"),
		 -command => [$buffer,'FileSave'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame1->Button( -image => $matrix->Photo(-file =>"$Bin/ledxml/export.gif"),
		 -command => [$buffer,'FileExportPopup'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );

$frame2->Button( -image => $matrix->Photo(-file =>"$Bin/ledxml/undo.gif"),
		 -command => [$buffer,'undo'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame2->Button( -image => $matrix->Photo(-file =>"$Bin/ledxml/redo.gif"),
		 -command => [$buffer,'redo'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );

$frame3->Button( -image => $matrix->Photo(-file =>"$Bin/ledxml/cut.gif" ),
		 -command => [$buffer,'clipboardCut'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame3->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/copy.gif"),
		 -command => [$buffer,'clipboardCopy'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame3->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/paste.gif"),
		 -command => [$buffer,'clipboardPaste'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame3->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/clear.gif"),
		 -command => [$buffer,'deleteSelected'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );

$frame4->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/find.gif"),
		 -command => [$buffer,'FindPopUp'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame4->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/next.gif"),
		 -command => [$buffer, 'FindSelectionNext'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame4->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/replace.gif"),
		 -command => [$buffer,'FindAndReplacePopUp'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );

$frame5->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/display.gif"),
		 -command => [$buffer,'displayArea'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame5->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/delete.gif"),
		 -command => [$buffer,'deleteArea'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame5->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/remove.gif"),
		 -command => [$buffer,'removeMarkups'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame5->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/write.gif"),
		 -command => [$buffer,'WriteTagPopUp'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame5->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/markup.gif"),
		 -command => [$buffer,'MarkupPopUp'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );

$frame6->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/cde.gif"),
		 -command => [$buffer,'FormalProximity'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame6->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/index.gif"),
		 -command => [$buffer,'showIndex'], -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame6->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/parse.gif"),
		 -command => \&showParser, -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );
$frame6->Button( -image => $matrix->Photo(-file=>"$Bin/ledxml/help.gif"),
		 -command => \&HelpPopup, -relief=>'flat',
		 -height=>17, -width=>17 )->pack( -side => 'left' );


my ( @group1 ) = $frame1->children();
my ( @group2 ) = $frame2->children();
my ( @group3 ) = $frame3->children();
my ( @group4 ) = $frame4->children();
my ( @group5 ) = $frame5->children();
my ( @group6 ) = $frame6->children();

$buffer->setHomeEnvironement( $ENV{HOME}? $ENV{HOME}: 0 );
$buffer->getEditPreferences();
$buffer->loadEditPreferences();
$buffer->loadStatusbar( $statusbar );

$buffer->Subwidget( 'yscrollbar' )->configure( -jump => 1 );
$buffer->SetGUICallbacks([sub {&UpdateIndicators();},
			  sub {$buffer->HighlightAllPairsBracketingCursor;},
                          sub {&UpdateMenu();}]);


$balloon->attach( $group1[0], -balloonmsg => "New",
		  -statusmsg => "'New' button activated" );
$balloon->attach( $group1[1], -balloonmsg => "Open",
		  -statusmsg => "'Open' button activated" );
$balloon->attach( $group1[2], -balloonmsg => "Include",
		  -statusmsg => "'Include' button activated" );
$balloon->attach( $group1[3], -balloonmsg => "Save",
		  -statusmsg => "'Save' button activated" );
$balloon->attach( $group1[4], -balloonmsg => "Export clipboard",
		  -statusmsg => "'Export' button activated" );

$balloon->attach( $group2[0], -balloonmsg => "Undo",
		  -statusmsg => "'Undo' button activated" );
$balloon->attach( $group2[1], -balloonmsg => "Redo",
		  -statusmsg => "'Redo' button activated" );

$balloon->attach( $group3[0], -balloonmsg => "Cut",
		  -statusmsg => "'Cut' button activated" );
$balloon->attach( $group3[1], -balloonmsg => "Copy",
		  -statusmsg => "'Copy' button activated" );
$balloon->attach( $group3[2], -balloonmsg => "Paste",
		  -statusmsg => "'Paste' button activated" );
$balloon->attach( $group3[3], -balloonmsg => "Clear",
		  -statusmsg => "'Clear' button activated" );

$balloon->attach( $group4[0], -balloonmsg => "Find",
		  -statusmsg => "'Find' button activated" );
$balloon->attach( $group4[1], -balloonmsg => "Find next",
		  -statusmsg => "'Find next' button activated" );
$balloon->attach( $group4[2], -balloonmsg => "Replace",
		  -statusmsg => "'Replace' button activated" );

$balloon->attach( $group5[0], -balloonmsg => "Display tag area",
		  -statusmsg => "'Display' button activated" );
$balloon->attach( $group5[1], -balloonmsg => "Delete tag area",
		  -statusmsg => "'Delete' button activated" );
$balloon->attach( $group5[2], -balloonmsg => "Remove markups",
		  -statusmsg => "'Clear' button activated" );
$balloon->attach( $group5[3], -balloonmsg => "Write tag",
		  -statusmsg => "'Write' button activated" );
$balloon->attach( $group5[4], -balloonmsg => "Markup selections",
		  -statusmsg => "'Markup' button activated" );

$balloon->attach( $group6[0], -balloonmsg => "Formal proximity",
		  -statusmsg => "'Proximity' button activated" );
$balloon->attach( $group6[1], -balloonmsg => "Index",
		  -statusmsg => "'Index' button activated" );
$balloon->attach( $group6[2], -balloonmsg => "Parser",
		  -statusmsg => "'Parser' button activated" );
$balloon->attach( $group6[3], -balloonmsg => "Help",
		  -statusmsg => "'Help' button activated" );

$toolsmenu->add( 'separator' );
$toolsmenu->add( 'command', -label => 'XML Parser', -underline => 4,
		 -command   => \&showParser, -accelerator => 'F8' );
$menu->Menubutton( -label => '~Help', -tearoff  => 0,
		   -menuitems => [['command'    => '~Help',
				   -command     => \&HelpPopup,
				   -accelerator => 'Ctrl+H'],
				  ['command'    => '~See License',
				   -command     => \&showLicense],
				  ['command'    => '~About edxml',
				   -command     => \&FrontPage]]);
$menu->menu->configure( -postcommand => \&UpdateMenu() );


$statusbar->pack( -side => 'bottom', -fill => 'x' );
$label->pack( -side => 'bottom', -fill => 'x' );

$frame0->pack( -side => 'top', -fill => 'x' );

$frame1->pack( -side => 'left' );
$frame2->pack( -side => 'left' );
$frame3->pack( -side => 'left' );
$frame4->pack( -side => 'left' );
$frame5->pack( -side => 'left' );
$frame6->pack( -side => 'left' );

$buffer->pack( -side => 'top', -fill => 'both', -expand => 1 );


MainLoop;


sub UpdateIndicators {

    my ( $file, $mode,
	 $line, $colon1,
	 $end, $colon2,
	 $top_visible, $bottom_visible, $percent );

    $file = $buffer->FileName();
    if ( defined( $file )) {
	if ( $file =~ /([^\/\\]+)$/ ) {
	    $file = $1;
	}
    }
    else { $file = "Unregistered"; }

    $mode = "(Insert Mode)";
    if ( $buffer->OverstrikeMode ) { $mode = "(Overstrike Mode)"; }

    ( $line, $colon1 ) = split( /\./, $buffer->index( 'insert' ));
    ( $end, $colon2 ) = split( /\./, $buffer->index( 'end' ));
    ( $top_visible, $bottom_visible ) = $buffer->yview();
    
    $bottom_visible = int( $bottom_visible * $end );
    $percent = int( $bottom_visible*100/$end );

    return( $label->configure( -text => "--:** ".$file."\t\t".$mode."--L".
	    $line."--C".$colon1."--TL".$end."--(".$percent."%)"));
}


sub UpdateMenu {

    my ( $filemenu, $editmenu, $searchmenu, $markupmenu, $selection );

    $filemenu    = $menu->entrycget( 0, '-menu' );
    $editmenu    = $menu->entrycget( 1, '-menu' );
    $searchmenu  = $menu->entrycget( 2, '-menu' );
    $markupmenu  = $menu->entrycget( 3, '-menu' );

    if ( $buffer->numberChanges ) {

	$filemenu->entryconfigure( 4, -state => 'normal' );
	$editmenu->entryconfigure( 0, -state => 'normal' );

	$group1[3]->configure( -state => 'normal' );
	$group2[0]->configure( -state => 'normal' );
    }

    else {

	$filemenu->entryconfigure( 4, -state => 'disabled' );
	$editmenu->entryconfigure( 0, -state => 'disabled' );

	$group1[3]->configure( -state => 'disabled' );
	$group2[0]->configure( -state => 'disabled' );
    }

    if ( $buffer->SizeRedo ) {
	$editmenu->entryconfigure( 1, -state => 'normal' );
	$group2[1]->configure( -state => 'normal' );
    }

    else {
	$editmenu->entryconfigure( 1, -state => 'disabled' );
	$group2[1]->configure( -state => 'disabled' );
    }

    eval { $selection = $buffer->SelectionGet( -selection=>"CLIPBOARD" );};
    unless ( $@ ) {

	$filemenu->entryconfigure( 6, -state => 'normal' );
	$editmenu->entryconfigure( 5, -state => 'normal' );

	$group1[4]->configure( -state => 'normal' );
	$group3[2]->configure( -state => 'normal' );
    }
    
    else {

	$filemenu->entryconfigure( 6, -state => 'disabled' );
	$editmenu->entryconfigure( 5, -state => 'disabled' );

	$group1[4]->configure( -state => 'disabled' );
	$group3[2]->configure( -state => 'disabled' );
    }
    
    if ( $buffer->tagRanges( 'sel' )) {

	$editmenu->entryconfigure( 3, -state => 'normal' );
	$editmenu->entryconfigure( 4, -state => 'normal' );
	$editmenu->entryconfigure( 6, -state => 'normal' );
	$editmenu->entryconfigure( 9, -state => 'normal' );
	
	$searchmenu->entryconfigure( 1, -state => 'normal' );
	$searchmenu->entryconfigure( 2, -state => 'normal' );

	$group3[0]->configure( -state => 'normal' );
	$group3[1]->configure( -state => 'normal' );
	$group3[3]->configure( -state => 'normal' );

	$group4[1]->configure( -state => 'normal' );
    }

    else {

	$editmenu->entryconfigure( 3, -state => 'disabled' );
	$editmenu->entryconfigure( 4, -state => 'disabled' );
	$editmenu->entryconfigure( 6, -state => 'disabled' );
	$editmenu->entryconfigure( 9, -state => 'disabled' );
	
	$searchmenu->entryconfigure( 1, -state => 'disabled' );
	$searchmenu->entryconfigure( 2, -state => 'disabled' );

	$group3[0]->configure( -state => 'disabled' );
	$group3[1]->configure( -state => 'disabled' );
	$group3[3]->configure( -state => 'disabled' );

	$group4[1]->configure( -state => 'disabled' );
    }
    

    if ( $buffer->getSafeMode ) {
	
	$markupmenu->entryconfigure( 11, -state => 'disabled' );
	$group5[4]->configure( -state => 'disabled' );

	if ($buffer->index( 'insert' ) != $buffer->getLastIndex ) {
		
	    $markupmenu->entryconfigure( 4, -state => 'disabled' );
	    $markupmenu->entryconfigure( 5, -state => 'disabled' );
	    $markupmenu->entryconfigure( 6, -state => 'disabled' );
	    $markupmenu->entryconfigure( 8, -state => 'disabled' );
	    $markupmenu->entryconfigure( 9, -state => 'disabled' );
	    
	    $group5[3]->configure( -state => 'disabled' );
	}
	else {
	    if (! $buffer->getXMLDecl ) {
		$markupmenu->entryconfigure( 4, -state => 'normal' );
	    }
	    if (! $buffer->getDoctype ) {
		$markupmenu->entryconfigure( 5, -state => 'normal' );
	    }
	    $markupmenu->entryconfigure( 6, -state => 'normal' );
	    $markupmenu->entryconfigure( 8, -state => 'normal' );
	    $markupmenu->entryconfigure( 9, -state => 'normal' );
		
	    $group5[3]->configure( -state => 'normal' );
	}
	if ( $buffer->FileName && $buffer->FileName !~ /\.xml$/ ) {
	    $toolsmenu->entryconfigure( 3, -state => 'disabled' );
	    $group6[2]->configure( -state => 'disabled' );
	}
	else {
	    $toolsmenu->entryconfigure( 3, -state => 'normal' );
	    $group6[2]->configure( -state => 'normal' );
	}
    }

    else {

	$markupmenu->entryconfigure( 0, -state => 'normal' );
	$markupmenu->entryconfigure( 1, -state => 'normal' );
	$markupmenu->entryconfigure( 2, -state => 'normal' );
	$markupmenu->entryconfigure( 4, -state => 'normal' );
	$markupmenu->entryconfigure( 5, -state => 'normal' );
	$markupmenu->entryconfigure( 6, -state => 'normal' );
	$markupmenu->entryconfigure( 8, -state => 'normal' );
	$markupmenu->entryconfigure( 9, -state => 'normal' );
	$markupmenu->entryconfigure( 11,-state => 'normal' );

	$toolsmenu->entryconfigure( 3, -state => 'normal' );

	$group5[3]->configure( -state => 'normal' );
	$group5[4]->configure( -state => 'normal' );
	$group6[2]->configure( -state => 'normal' );
    }
}


sub showParser {

    if (! Exists( $top1 )) {	
	$buffer->tellStatusbar( "Preparing the parser..." );
	
	$top1 = $buffer->Toplevel();
	my ( $parser ) = $top1->Scrolled( 'XMLViewer', -scrollbars => 'osoe',
					  -background => "#ffefffffe0c3",
					  -selectforeground => 'white',
					  -selectbackground => "#000070669645",
					  -height => 22, -width => 70,
					  -setgrid => 'true' );
	
	my ( $menu )    = $top1->Menu();
	$menu->Menubutton( -label => 'File', -tearoff => 0, -underline=>0,
			   -menuitems =>[
					 ['command' => '~Parse Edits',
					  -command=> sub {
			   $buffer->tellStatusbar( "Parsing edits..." );
			   $parser->delete( '1.0', 'end' );
			   $parser->insertXML( -text =>
					       $buffer->get('1.0','end' ));
			   $buffer->tellStatusbar( "Edits were parsed." );
		       }],
					 ['command' => 'Parse ~File',
					  -command=> sub {

			   my ( $file ) = $buffer->CreateFileSelect(
				       'getOpenFile',
				        -title =>"File Parse",
					-filetypes=> [["Xml Files", '.xml']]);
			   if ( defined( $file ) and length( $file )) {
	    
			       $buffer->tellStatusbar( "Parsing \"$file\"...");
			       $parser->delete( '1.0', 'end' );
			       $parser->insertXML( -file => $file );
			       return( $buffer->tellStatusbar
				       ( "File \"$file\" was parsed." ));
			   }
			   else {
			       return( $buffer->tellStatusbar
				       ( "Action chanceled!" ));
			   }
		       }], '-',
					 ['command' => '~Exit',
					  -command=> sub{$top1->destroy();}]]);
    
	my ( $cascade ) = $menu->cascade( -tearoff => 0, -label => 'XML',
					  -underline=>0 );
	$cascade->command( -label=>'~Info',
			   -command => sub{$parser->Showinfo;});
	my ( $entry ) = $cascade->cascade( -tearoff => 0,
					   -label => 'Show To ~Depth' );
	for my $depth (1 .. 6) {
	    my $_depth = $depth;
	    $entry->command( -label => $depth,
			     -command=>sub { $parser->ShowToDepth($_depth) });
	}
	$entry->command(-label => 'Open ~All',
			-command => sub { $parser->ShowToDepth(undef) });
	
	$menu->Menubutton( -label => 'View', -tearoff => 0, -underline=>0,
			   -menuitems =>[@{$parser->ViewMenuItems}] );
	
	$top1->configure( -title => "Parser", -menu => $menu );
	$top1->bind( 'Tk::XMLViewer', '<Button-3>', sub {});
	
	$parser->pack( -fill => 'both', -expand => 1 );
	$top1->resizable( 0, 0 );
	
	$buffer->tellStatusbar( "Parsing edits..." );
	$parser->insertXML( -text => $buffer->get('1.0','end' ));

	return( $buffer->tellStatusbar( "Edits were parsed." ));
    }
    return( 0 );
}


sub HelpPopup {

    if (! Exists( $top2 )) {	
	$buffer->tellStatusbar( "Showing the help window..." );
    
	$top2 = $matrix->Toplevel( -title => 'Help' );
	my ( $window ) = $top2->Scrolled( 'ROText', -scrollbars => 'osoe',
					  -background => "#ffefffffe0c3",
					  -selectforeground => 'white',
					  -selectbackground => "#000070669645",
					  -height => 22, -width=> 70,
					  -wrap=> 'word' );
	my ( $menu ) = $top2->Menu();
	$window->tagConfigure( 'title', -justify=>'center',
			       -foreground=>'red' );
	$window->tagConfigure( 'blue', -foreground => 'blue' );
	$menu->Menubutton( -label => 'File',
			   -tearoff  => 0, -underline => 0,
			   -menuitems => [
					  
			    ['command'  => '~General',
			     -command => sub { &GeneralHelp( $window );}],     
			    ['command' => '~Bindings',
			     -command => sub { &BindingsHelp( $window );}],
			    '-',
			    ['command' => '~Exit',
			     -command => sub {$top2->destroy();}]]);
	$menu->Menubutton( -label => 'View', -tearoff => 0, -underline=>0,
			   -menuitems =>[@{$window->ViewMenuItems}] );
    
	$top2->resizable( 0, 0 );
	$top2->configure( -menu => $menu );
	
	$window->bind( 'Tk::ROText', '<Button-3>', '' );
	$window->pack();
	&GeneralHelp ( $window );
	
	return( $buffer->tellStatusbar( "'Help' window displayed." ));
    }
    return( 0 );
}


sub GeneralHelp {

    my ( $window ) = @_;

    $window->delete('1.0', 'end' );
    $window->insert( 'end', "DESCRIPTION\n\n", 'title' );
    
    
    $window->insert( 'end', "\tedxml ", 'blue' );
    $window->insert( 'end', "is a small editor providing routines for text manipulation, such as search and replacement tools and XML tags edition. Part of an E.N.S. Lyon project, " );
    $window->insert( 'end', "edxml ", 'blue' );
    $window->insert( 'end', "is intended to perform specific tasks upon linguistic corpora, consisting in the exploration of the formal proximity between enouncements, assisted tag placement, extraction, deletion and export of markup strings. The user can propose definitions for textual phenomena via the Perl regular expressions and then isolate and mark them with standard XML flags.\n\n\tFeatures of " );
    $window->insert( 'end', "edxml ", 'blue' );
    $window->insert( 'end', "include special characters matching. The module looks at the current cursor position and then tries to find the character pair that brackets the cursor. Characters that are searched for are: " );
    $window->insert( 'end', "<> () {} [] \"\"", 'blue' );
    $window->insert( 'end', ". It also checks the position of these pairs and try to highlight bad positions. If the character couples are not on the same line or not in the same column, then there might be a missing parenthesis somewhere. Characters that appear to not align are highlighted in red.\n\n\t" );
    $window->insert( 'end', "edxml ", 'blue' );
    $window->insert( 'end', "is free software. Please see the license terms for information on its use and redistribution, and for a DISCLAIMER OF ALL WARRANTIES.\n\n" );
    
    
    $window->insert( 'end', "MODULES AND USE\n\n", 'title' );
    
    $window->insert( 'end', "\tedxml ", 'blue' );
    $window->insert( 'end', "has the structure of a traditional text editor: a main window, a buffer for edits, menus and buttons. The tasks to perform upon the loaded file are activated through the menus or the buttons which are shortcuts for some of the routines already listed in the menus.\n\n\t" );
    
    
    $window->insert( 'end', "The File menu\n\n\tNew ", 'blue' );
    $window->insert( 'end', ": loads a new file. This file may be registered with the " );
    $window->insert( 'end', "Save", 'blue' );
    $window->insert( 'end', ", " );
    $window->insert( 'end', "Save As ", 'blue' );
    $window->insert( 'end', "commands.\n\t" );
    $window->insert( 'end', "Open ", 'blue' );
    $window->insert( 'end', ": calls a dialog box for the selection of an existing file.\n\t");
    $window->insert( 'end', "Include ", 'blue' );
    $window->insert( 'end', ": inserts the contents of an external file
 at the cursor point, without deleting the \"undo\" information of the current file.\n\t" );
    $window->insert( 'end', "Save ", 'blue' );
    $window->insert( 'end', ": saves edits by calling a dialog box if the document was not registered.\n\t" );
    $window->insert( 'end', "Save As ", 'blue' );
    $window->insert( 'end', ": saves the loaded file by calling a dialog box providing the possibility of changing the file name.\n\t" );
    $window->insert( 'end', "Export ", 'blue' );
    $window->insert( 'end', ": exports the clipboard selection to a file, selected with a dialog box. Before using this option, you have to copy the primary selection of the buffer to the clipboard. You may export several selections to a file ( the ancient exports will not be deleted ).\n\t" );
    $window->insert( 'end', "Exit ", 'blue' );
    $window->insert( 'end', ": closes the application.\n\n\t" );
    
    
    $window->insert( 'end', "The Edit menu\n\n\t", 'blue' );
    $window->insert( 'end', "Undo ", 'blue' );
    $window->insert( 'end', ": undoes the last action.\n\t" );
    $window->insert( 'end', "Redo ", 'blue' );
    $window->insert( 'end', ": re-makes edits step by step.\n\t" );
    $window->insert( 'end', "Cut ", 'blue' );
    $window->insert( 'end', ": deletes the primary selection of the buffer and pushes its contents in the clipboard.\n\t" );
    $window->insert( 'end', "Copy ", 'blue' );
    $window->insert( 'end', ": copies the primary selection of the buffer to the clipboard.\n\t" );
    $window->insert( 'end', "Paste ", 'blue' );
    $window->insert( 'end', ": inserts the clipboard selection into the buffer, at the cursor point.\n\t" );
    $window->insert( 'end', "Clear ", 'blue' );
    $window->insert( 'end', ": deletes the primary selection of the buffer.\n\t" );
    $window->insert( 'end', "Select All ", 'blue' );
    $window->insert( 'end', ": marks all the lines of the buffer as a primary selection.\n\t" );
    $window->insert( 'end', "Unselect All ", 'blue' );
    $window->insert( 'end', ": clears all the selected regions of the buffer.\n\n\t" );
    
    
    $window->insert( 'end', "The Search menu\n\n\t", 'blue' );
    $window->insert( 'end', "Find ", 'blue' );
    $window->insert( 'end', ": searches for a given string in the buffer. Arguments such as \"direction\", \"case\" and \"mode\" may be controlled. The '-regexp' mode is the most important argument for this program. It offers all the power of the Perl regular expressions, including the backup references. The search may be global.\n\t" );
    $window->insert( 'end', "Find Next ", 'blue' );
    $window->insert( 'end', ": searches '-forward' for the selected string in the application and stops after the first occurrence of the motif found.\n\t" );
    $window->insert( 'end', "Find Previous ", 'blue' );
    $window->insert( 'end', ": searches '-backward' for the selected string in the application and stops after the first occurrence of the motif found.\n\t" );
    $window->insert( 'end', "Replace ", 'blue' );
    $window->insert( 'end', ": searches for a given string in the buffer and replace its instances with another string. The search has the same controllable arguments as described for the Find option and may be global.\n\n\t" );
    
    
    $window->insert( 'end', "The Markup menu\n\n\t", 'blue' );
    $window->insert( 'end', "This menu refers to the manipulation of the standard XML tags. The formal representation for these tags is \"<[^>]+>\". There are two edit modes for the XML documents: an assisted mode, through the interface provided by this menu, and a manual mode. During the non-assisted manipulation of the buffer, the syntax corrector and other facilities will be desactivated. If you want to return to the assisted mode while working in safe mode, you should just press the " );
    $window->insert( 'end', "<F5> ", 'blue' );
    $window->insert( 'end', "key which will reset the XML indicators and indent the selected line.\n\n\t" );
    
    $window->insert( 'end', "Display Tag Area ", 'blue' );
    $window->insert( 'end', ": searches for text areas marked with the given tag in the buffer. The search may be global.\n\t" );
    $window->insert( 'end', "Delete Tag Area ", 'blue' );
    $window->insert( 'end', ": searches for text areas marked with the given tag in the buffer and deletes them. The deletion may be global for one tag.\n\t" );
    $window->insert( 'end', "Remove Markups ", 'blue' );
    $window->insert( 'end', ": removes all the tags from the buffer.\n\t" );
    $window->insert( 'end', "XML Declaration ", 'blue' );
    $window->insert( 'end', ": checks the edits for XML syntax and inserts an XML declaration at the cursor point.\n\t" );
    $window->insert( 'end', "Document Type ", 'blue' );
    $window->insert( 'end', ": checks the edits for XML syntax and inserts a Document type declaration at the cursor point.\n\t" );
    $window->insert( 'end', "Insert Comment ", 'blue' );
    $window->insert( 'end', ": inserts an XML comment at the cursor point.\n\t" );
    $window->insert( 'end', "Write Tag ", 'blue' );
    $window->insert( 'end', ": pops up a tag write dialog, then inserts the collected informations, if checked OK, as a start tag, an empty tag or an end tag, at the cursor position .\n\t" );
    $window->insert( 'end', "Insert Text ", 'blue' );
    $window->insert( 'end', ": inserts a text string at the cursor point.\n\t" );
    $window->insert( 'end', "Markup Selections ", 'blue' );
    $window->insert( 'end', ": takes a motif and search for its instances in the buffer. There are three controllable arguments : \"direction\", \"mode\" and \"case\". Then, if a tag name is provided, the routine will mark the selections with the given tag. This menu entry can be used only if the \"Unsafe Mode\" is checked in the options.\n\n\t" );
    
    
    $window->insert( 'end', "The Tools menu\n\n\t", 'blue' );
    
    $window->insert( 'end', "Show Index ", 'blue' );
    $window->insert( 'end', ": pops up a top level with a list widget and a menu. The menu provides entries commanding the extraction of all the lexical forms from the loaded file or the listing of the tag names, attributes, values and  comments from an XML document.\n\t" );
    $window->insert( 'end', "Proximity ", 'blue' );
    $window->insert( 'end', ": pops up a control top level for routines that calculate the formal distances between enouncements. The delimiters are \".!?\". A score is made with the common atoms ( forms, bigrams ) of two enouncements and and the specific atoms of each enouncement. You can structure the corpus by placing in the buffer a special tag \"key\", of the type " );
    $window->insert( 'end', "<key string=\"value\"> ", 'blue' );
    $window->insert( 'end', "and then specify \"string\" as an argument, in order to avoid too many iterations.\n\t" );
    $window->insert( 'end', "XML Parser ", 'blue' );
    $window->insert( 'end', ": pops up a top level with a read-only text widget which can display parsed contents. It provides a menu with entries controlling the text wrap and the closure of the XML objects according to the requested depth.\n\n\t" );
    
    $window->insert( 'end', "The View menu\n\n\t", 'blue' );  
    $window->insert( 'end', "Goto Line ", 'blue' );
    $window->insert( 'end', ": moves the cursor to the line number.\n\t" );
    $window->insert( 'end', "Wrap ", 'blue' );
    $window->insert( 'end', ": controls the line wrap.\n\t" );
    $window->insert( 'end', "Preferences ", 'blue' );
    $window->insert( 'end', ": shows the controls for the edit modes and the general configuration of the application.\n\n\t" );
    
    
    $window->insert( 'end', "The Help menu\n\n\t", 'blue' );
    $window->insert( 'end', "Help ", 'blue' );
    $window->insert( 'end', ": pops up a help window which can display these contents.\n\t" );
    $window->insert( 'end', "License ", 'blue' );
    $window->insert( 'end', ": pops up a read-only text widget displaying the license of " );
    $window->insert( 'end', "edxml", 'blue' );
    $window->insert( 'end', ".\n\t" );
    $window->insert( 'end', "About edxml ", 'blue' );
    $window->insert( 'end', ": pops up the front page of " );
    $window->insert( 'end', "edxml", 'blue' );
    $window->insert( 'end', ".\n\n" );
}


sub BindingsHelp {

    my ( $window ) = @_;

    $window->delete( '1.0', 'end' );
    $window->insert( 'end', "MOUSE BINDINGS\n\n", 'title' );
    
    $window->insert( 'end', "\tClicking mouse button 1 positions the insertion cursor just before the character underneath the mouse cursor, sets the input focus to this widget, and clears any selection in the widget. Dragging with mouse button 1 strokes out a selection between the insertion cursor and the character under the mouse.

\tDouble-clicking with mouse button 1 selects the word under the mouse and positions the insertion cursor at the beginning of the word. Dragging after a double click will stroke out a selection consisting of whole words.

\tTriple-clicking with mouse button 1 selects the line under the mouse and positions the insertion cursor at the beginning of the line. Dragging after a triple click will stroke out a selection consisting of whole lines.

\tThe ends of the selection can be adjusted by dragging with mouse button 1 while the " );
    $window->insert( 'end', "<Shift> ", 'blue' );
    $window->insert( 'end', "key is down;  this will adjust the end of the selection that was nearest to the mouse cursor when button 1 was pressed. If the button is double-clicked before dragging then the selection will be adjusted in units of whole words;  if it is triple-clicked then the selection will be adjusted in units of whole lines.

\tClicking mouse button 1 with the " );
    $window->insert( 'end', "<Control> ", 'blue' );
    $window->insert( 'end', "key down will reposition the insertion cursor without affecting the selection.

\tIf any normal printing characters are typed, they are inserted at the point of the insertion cursor.

\tThe view in the widget can be adjusted by dragging with mouse button 2. If mouse button 2 is clicked without moving the mouse, the selection is copied into the text at the position of the mouse cursor. The " );
    $window->insert( 'end', "<Insert> ", 'blue' );
    $window->insert( 'end', "key also inserts the selection, but at the position of the insertion cursor.

\tIf the mouse is dragged out of the widget while button 1 is pressed, the entry will automatically scroll to make more text visible ( if there is more text off-screen on the side where the mouse left the window ).\n\n" );
    
    $window->insert( 'end', "KEYBOARD BINDINGS\n\n", 'title' );
    
    $window->insert( 'end', "\tThe " );
    $window->insert( 'end', "<Left> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Right> ", 'blue' );
    $window->insert( 'end', "keys move the insertion cursor one character to the left or right;  they also clear any selection in the text. If " );
    $window->insert( 'end', "<Left> ", 'blue' );
    $window->insert( 'end', "or " );
    $window->insert( 'end', "<Right> ", 'blue' );
    $window->insert( 'end', "is typed with the " );
    $window->insert( 'end', "<Shift> ", 'blue' );
    $window->insert( 'end', "key down, then the insertion cursor moves and the selection is extended to include the new character. " );
    $window->insert( 'end', "<Control-Left> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Right> ", 'blue' );
    $window->insert( 'end', "move the insertion cursor by words, and " );
    $window->insert( 'end', "<Control-Shift-Left> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Shift-Right> ", 'blue' );
    $window->insert( 'end', "move the insertion cursor by words and also extend the selection. " );
    $window->insert( 'end', "<Meta-b> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Meta-f> ", 'blue' );
    $window->insert( 'end', "behave the same as " );
    $window->insert( 'end', "<Control-Left> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Right>", 'blue' );
    $window->insert( 'end', ", respectively.\n\n" );
    
    $window->insert( 'end', "\tThe " );
    $window->insert( 'end', "<Up> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Down> ", 'blue' );
    $window->insert( 'end', "keys move the insertion cursor one line up or down and clear any selection in the text. If " );
    $window->insert( 'end', "<Up> ", 'blue' );
    $window->insert( 'end', "or " );
    $window->insert( 'end', "<Right> ", 'blue' );
    $window->insert( 'end', "is typed with the " );
    $window->insert( 'end', "<Shift> ", 'blue' );
    $window->insert( 'end', "key down, then the insertion cursor moves and the selection is extended to include the new character. " );
    $window->insert( 'end', "<Control-Up> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Down> ", 'blue' );
    $window->insert( 'end', "move the insertion cursor by paragraphs (lines separated by blank lines), and " );
    $window->insert( 'end', "<Control-Shift-Up> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Shift-Down> ", 'blue' );
    $window->insert( 'end', "move the insertion cursor by paragraphs and also extend the selection.\n\n\tThe " );
    
    $window->insert( 'end', "<Next> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Prior> ", 'blue' );
    $window->insert( 'end', "keys move the insertion cursor forward or backwards by one screenful and clear any selection in the text. If the " );
    $window->insert( 'end', "<Shift> ", 'blue' );
    $window->insert( 'end', "key is held down while Next or Prior is typed, then the selection is extended to include the new character. " );
    $window->insert( 'end', "<Control-v> ", 'blue' );
    $window->insert( 'end', "moves the view down one screenful without moving the insertion cursor or adjusting the selection.\n\n\t" );
    
    $window->insert( 'end', "<Control-Next> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Prior> ", 'blue' );
    $window->insert( 'end', "scroll the view right or left by one page without moving the insertion cursor or affecting the selection.\n\n\t" );
    
    $window->insert( 'end', "<Home> ", 'blue' );
    $window->insert( 'end', "moves the insertion cursor to the beginning of its line and clear any selection in the widget. " );
    $window->insert( 'end', "<Shift-Home> ", 'blue' );
    $window->insert( 'end', "moves the insertion cursor to the beginning of the line and also extends the selection to that point.\n\n\t" );
    
    
    $window->insert( 'end', "<End> ", 'blue' );
    $window->insert( 'end', "moves the insertion cursor to the end of the line and clear any selection in the widget. " );
    $window->insert( 'end', "<Shift-End> ", 'blue' );
    $window->insert( 'end', "moves the cursor to the end of the line and extends the selection to that point.\n" );
    
    $window->insert( 'end', "<Control-Home> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Meta-<> ", 'blue' );
    $window->insert( 'end', "move the insertion cursor to the beginning of the text and clear any selection in the widget. " );
    $window->insert( 'end', "<Control-Shift-Home> ", 'blue' );
    $window->insert( 'end', "moves the insertion cursor to the beginning of the text and also extends the selection to that point.\n\n\t" );
    
    $window->insert( 'end', "<Control-End> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Meta->> ", 'blue' );
    $window->insert( 'end', "move the insertion cursor to the end of the text and clear any selection in the widget. " );
    $window->insert( 'end', "<Control-Shift-End> ", 'blue' );
    $window->insert( 'end', "moves the cursor to the end of the text and extends the selection to that point.\n\n\tThe " );
    
    
    $window->insert( 'end', "<Select> ", 'blue' );
    $window->insert( 'end', "key and " );
    $window->insert( 'end', "<Control-Space> ", 'blue' );
    $window->insert( 'end', "set the selection anchor to the position of the insertion cursor. They don't affect the current selection. " );
    $window->insert( 'end', "<Shift-Select> " );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Shift-Space> ", 'blue' );
    $window->insert( 'end', "adjust the selection to the current position of the insertion cursor, selecting from the anchor to the insertion cursor if there was not any selection previously.\n\n\t" );
    
    
    $window->insert( 'end', "<Control-n> ", 'blue' );
    $window->insert( 'end', "opens a new file.\n\t" );
    $window->insert( 'end', "<Control-s> ", 'blue' );
    $window->insert( 'end', "saves the loaded file.\n\t" );
    $window->insert( 'end', "<Control-e> ", 'blue' );
    $window->insert( 'end', "exports the clipboard to the selected file (preserving its contents, if any).\n\t" );
    $window->insert( 'end', "<Control-/> ", 'blue' );
    $window->insert( 'end', "selects the entire contents of the widget.\n\n\t" );
    $window->insert( 'end', "<Control-\\> ", 'blue' );
    $window->insert( 'end', " clears any selection in the widget.\n\n\t" );  
    $window->insert( 'end', "<F5> ", 'blue' );
    $window->insert( 'end', "updates the XML indicators and indents the selected line.\n\t" );
    $window->insert( 'end', "<F6> ", 'blue' );
    $window->insert( 'end', "calls the control top level for the routines that calculate the formal proximity between enouncements.\n\t" );
    $window->insert( 'end', "<F7> ", 'blue' );
    $window->insert( 'end', "pops up the XML index.\n\t" );
    $window->insert( 'end', "The " );
    $window->insert( 'end', "<F8> ", 'blue' );
    $window->insert( 'end', "key calls the XML parser.\n\t" );
    $window->insert( 'end', "The " );
    $window->insert( 'end', "<F16> ", 'blue' );
    $window->insert( 'end', "key (labeled Copy on many Sun workstations) or " );
    
    $window->insert( 'end', "<F1>", 'blue' );
    $window->insert( 'end', ", or " );
    $window->insert( 'end', "<Meta-w> ", 'blue' );
    $window->insert( 'end', "copies the selection in the widget to the clipboard, if there is a selection.\n\n\t" );
    $window->insert( 'end', "The " );
    $window->insert( 'end', "<F20> ", 'blue' );
    $window->insert( 'end', "key (labeled Cut on many Sun workstations) or " );
    $window->insert( 'end', "<F2>", 'blue' );
    $window->insert( 'end', ", or " );
    $window->insert( 'end', "<Control-w> ", 'blue' );
    $window->insert( 'end', "copies the selection in the widget to the clipboard and deletes the selection. If there is no selection in the widget then these keys have no effect.\n\n\t" );
    
    $window->insert( 'end', "The " );
    $window->insert( 'end', "<F18> ", 'blue' );
    $window->insert( 'end', "key (labeled Paste on many Sun workstations) or " );
    $window->insert( 'end', "<F3>", 'blue' );
    $window->insert( 'end', ", or " );
    $window->insert( 'end', "<Control-y> ", 'blue' );
    $window->insert( 'end', "inserts the contents of the clipboard at the position of the insertion cursor.\n\n\t" );
    
    $window->insert( 'end', "<Control-f> ", 'blue' );
    $window->insert( 'end', "calls the search dialog.\n\t" );
    $window->insert( 'end', "<Control-r> ", 'blue' );
    $window->insert( 'end', "calls the replacement dialog.\n\t" );
    $window->insert( 'end', "<Control-m> ", 'blue' );
    $window->insert( 'end', "calls the markup dialog.\n\t" );
    $window->insert( 'end', "<Control-t> ", 'blue' );
    $window->insert( 'end', "calls the tag write dialog.\n\t" );
    $window->insert( 'end', "<Control-h> ", 'blue' );
    $window->insert( 'end', "pops up the help top level.\n\n\t" );
    
    $window->insert( 'end', "The " );
    $window->insert( 'end', "<Delete> ", 'blue' );
    $window->insert( 'end', "key deletes the selection, if there is one in the widget. If there is no selection, it deletes the character to the right of the insertion cursor.\n\n\t" );
    
    $window->insert( 'end', "<Backspace> ", 'blue' );
    $window->insert( 'end', "deletes the selection, if there is one in the widget. If there is no selection, then deletes the character to the left of the insertion cursor.\n\t" );
    
    $window->insert( 'end', "<Control-d> ", 'blue' );
    $window->insert( 'end', "deletes the character to the right of the insertion cursor.\n\t" );
    
    $window->insert( 'end', "<Meta-d> ", 'blue' );
    $window->insert( 'end', "deletes the word to the right of the insertion cursor.\n\t" );
    
    $window->insert( 'end', "<Control-k> ", 'blue' );
    $window->insert( 'end', "deletes everything from the insertion cursor to the end of the line; if the insertion cursor is already at the end of a line, then " );
    $window->insert( 'end', "<Control-k> ", 'blue' );
    $window->insert( 'end', "deletes the newline character.\n\t" );
    
    $window->insert( 'end', "<Control-o> ", 'blue' );
    $window->insert( 'end', "opens a new line by inserting a newline character in front of the insertion cursor without moving the insertion cursor.\n\t" );
    
    $window->insert( 'end', "<Meta-backspace> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Meta-Delete> ", 'blue' );
    $window->insert( 'end', "delete the word to the left of the insertion cursor.\n\n\t" );
    
    $window->insert( 'end', "<Control-x> ", 'blue' );
    $window->insert( 'end', "deletes whatever is selected in the text widget.\n\t" );
    $window->insert( 'end', "Pressing " );    
    $window->insert( 'end', "<L4> ", 'blue' );
    $window->insert( 'end', "several times undoes step by step the changes made to the text widget.\n\n\t" );
}


sub showLicense {

    if (! Exists( $top3 )) {
	$buffer->tellStatusbar( "Showing the license..." );

	$top3   = $matrix->Toplevel( -title => 'License' );
	my ( $window ) = $top3->Scrolled( 'ROText', -background => "#ffefffffe0c3",
					  -selectforeground => 'white',
					  -selectbackground => "#000070669645",
					  -scrollbars => 'oe',
					  -width      => 47,
					  -height     => 14,
					  -wrap       => 'word' );
	my ( $menu )    = $top3->Menu();
	my ( $license ) = "\tThis program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation;\n\n\tedxml is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. If you have not a copy of the GNU General Public License, please write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.\n\n\tThe Berkeley DB module is free of charge under the condition that the complete source code for the application must be available and freely redistributable.\n\n\tThe Perl2exe compiler may be used at no charge during an evaluation period of 30 days.";
    
	$top3->resizable( 0, 0 );
	$top3->configure( -menu => $menu );
	$menu->Menubutton( -label => "File", -tearoff => 0, -underline => 0,
			   -menuitems =>[['command' => '~Exit',
					  -command=> sub{$top3->destroy();}]]);
	
	$window->insert( 'end', $license );
	$window->bind( 'Tk::ROText', '<Button-3>', '' );

	$window->pack();
	return( $buffer->tellStatusbar( "License displayed." ));
    }
    return( 0 )
}


sub FrontPage {

    if (! Exists( $top4 )) {	
	$buffer->tellStatusbar( "Showing the front page..." );
	
	$top4    = $matrix->Toplevel( -title => 'About edxml' );
	my ( $image )  = $top4->Photo( -file => "$Bin/ledxml/logo.gif" );
	my ( $label )  = $top4->Label( -image => $image );
	my ( $menu )  = $top4->Menu();
	
	$top4->resizable( 0, 0 );
	$top4->configure( -menu => $menu );
	$menu->Menubutton( -label => "File", -tearoff => 0, -underline => 0,
			   -menuitems =>[['command' => '~Exit',
					  -command => sub{ $top4->destroy;}]]);
	
	$label->pack();
	return( $buffer->tellStatusbar( "Front page displayed." ));
    }
    return( 0 );
}

}


#---------------------------------------------






#------------------------------------------------------------------------
1;

