#!/usr/bin/perl -w

# author G.P.H. Josten <gjosten@sci.kun.nl>
# post processing by Michel Rodriguez <m.v.rodriguez@ieee.org>

use strict;
use XML::XSLT qw(serve); 
#use XML::XSLT::Parser; 

set_filter();    # sets the post-processing filter
#my $xslt   = XML::XSLT->new( 'ex_ps_xslt.xslt');
#print $xslt->serve( Source => 'REC-xml-19980210.xml');
my $xslt   = XML::XSLT->new( 'bibliographie.xsl');
print $xslt->serve( Source => 'bibliographie.xml');

exit;

sub set_filter
  { return if my $pid= open( STDOUT, "|-");    # magic open
    die "cannot fork: $!" unless defined $pid;

    my $i=0;
    my $prod='';
    while( <STDIN>)
      { if( m/^\s*\[\]/)
          { unless( $i==0)
              { $prod= add_pos( $prod, $i); 
                $prod= clean_prod( $prod); 
                print "$prod\n" ;
              }
            $i++;
            $prod= '';
          }
          $prod .= $_;
        }
    $prod= add_pos( $prod, $i); 
    $prod= clean_prod( $prod); 
    print "$prod\n"; 
    exit;
  }
        
        
sub clean_prod 
  { my $prod= shift;
    $prod=~ s/&#160;/ /g;
    $prod=~ s{\n}{ };
    $prod=~ s{\s+}{ }g;
    $prod=~ s{^\s*}{}g;
    $prod=~ s{\s*$}{}g;
    # those are escaped in XML::XSLT
    $prod=~ s{&lt;}{<}g;  
    $prod=~ s{&gt;}{>}g;  
    $prod=~ s{&amp;}{&}g; 
    return $prod;
  }

sub add_pos                                    # needed because XSLT does not
  { my( $prod, $i)= @_;                        # yet implement position()
    $prod=~ s{^\s*\[\]}{\n[$i]};
    return $prod;
  }



