package HTMLQC;

use strict;
use vars qw/@ISA @EXPORT $error/;
require Exporter;
@ISA = 'Exporter';
@EXPORT = qw (htmlqc);
use SHTML;
 
my %tagpair = (
               'A',         1,
         'ADDRESS',         1,
               'B',         1,
      'BLOCKQUOTE',         1,
              'BQ',         1,
          'CENTER',         1,
            'CITE',         1,
            'CODE',         1,
             'DFN',         1,
             'DIR',         1,
              'DL',         1,
              'EM',         1,
             'FIG',         1,
            'FONT',         1,
            'FORM',         1,
              'H1',         1,
              'H2',         1,
              'H3',         1,
              'H4',         1,
              'H5',         1,
              'H6',         1,
            'HEAD',         1,
            'HTML',         1,
               'I',         1,
             'KBD',         1,
         'LISTING',         1,
            'MATH',         1,
            'MENU',         1,
              'OL',         1,
             'PRE',         1,
               'S',         1,
            'SAMP',         1,
          'SELECT',         1,
          'STRONG',         1,
           'STYLE',         1,
           'TABLE',         1,
        'TEXTAREA',         1,
           'TITLE',         1,
              'TD',         1,
              'TR',         1,
              'TT',         1,
               'U',         1,
              'UL',         1,
             'VAR',         1,
             'XMP',         1,
      'BLOCKQUOTE',         1,
);

sub htmlqc
{
    my ($html) = @_;

    $error = '';
    my %taghistory = ();
    $html = striptohtml($html);

    for $_ (split(/\n/,$html))
    {
        unless (anglematch($_)) 
        {
            $error .= "  Mismatched < and >, line: $_\n";
        }
        if (my ($starttag) = m#<\s*([^/\s]+)[^>]*>#)
        {
            $starttag =~ tr/a-z/A-Z/;
            $taghistory{$starttag}++ if ($tagpair{$starttag});
        }
        elsif (my ($endtag) = m#</\s*([^\s]+)[^>]*>#)
        {
            $endtag =~ tr/a-z/A-Z/;
            if ($tagpair{$endtag})
            {
                if ($taghistory{$endtag})
                {
                    $taghistory{$endtag}--;
                }
                else
                {
                    $error .= "  Endtag </$endtag> mismatch\n";
                }
            }
        }
    }
    for my $tag (keys %taghistory)
    {
        $error .= 
            "  Tag <$tag> has $taghistory{$tag} tags to close\n"
            if $taghistory{$tag};
    }
    $error ? 0 : 1;
}

sub anglematch
{
    return 1 if (/<!--/ or /-->/);
    return 0 if /<[^>]*</m;
    return 0 if />[^<]*>/m;
    return 0 if /<[^>]*$/m;
    return 0 if /^[^<]*>/m;
    1;
}

1;
