##############################################################################
#AUTHORS: 	Fleury Serge
#VERSION: 	1.0.2
#email:		serge.fleury@univ-paris3.fr
#url:		http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/mkcorpusProject.htm
#date:		June/2002
#FILE:
#    This file is part of MKCorpus.
##############################################################################
use Tk;
use Tk::Dialog;
use Tk::DialogBox;
use Tk::TextUndo;
use Tk::Photo;
use XML::XPath;
use XML::XPath::XMLParser;	

$main = MainWindow->new(-title=>'CollocInXPath :');
$main->geometry("400x300+100+100");
my $imgLogo=$main->Photo(-file=>"logo-mkc.gif");
my $lblLogo=$main->Button(-image=>$imgLogo)->place(-y=>0,-x=>0,-width=>400,-height=>300);
my $frame1 = $main->Frame()->pack(-side=>'bottom', -pady=>5);
my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);
my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);
my $frame2 = $main->Frame()->pack();
my $frame3 = $main->Frame()->pack();
my $libelF = $frameG2->Label(-text=>'File (input) :')->pack(-padx=>5);
my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
$montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
    ->pack(		-fill => 'x',
			-expand => 1);
$defil->pack(-fill => 'x',
	     -expand => 1);
$defil->configure(-command => [$montantF => 'xview']);
my $libelE = $frameG3->Label(-text=>'Node (XPath) :')->pack(-padx=>5);
my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");
$montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
    ->pack(		-fill => 'x',
			-expand => 1);
$defil2->pack(-fill => 'x',
	      -expand => 1);
$defil2->configure(-command => [$montantE => 'xview']);
my $raz = $main->Button(-text=>'RAZ', -activeforeground=>"blue",-relief=>'flat', -command=>\&viderMontant)->pack(-side=>'left', -padx=>5, -pady=>5);
my $calcul = $main->Button(-text=>'Colloc', -activeforeground=>"blue",-relief=>'flat', -command=>\&loadcollocInXPath)->pack(-side=>'left', -padx=>5, -pady=>5);
my $help = $main->Button(-text=>'Help', -activeforeground=>"blue",-relief=>'flat', -command=>\&helpcollocInXPath)->pack(-side=>'right', -padx=>5, -pady=>5);
my $fin = $main->Button(-text=>'Exit', -activeforeground=>"blue",-relief=>'flat', -command=>sub {$main->destroy()})->pack(-side=>'right', -padx=>5, -pady=>5);

MainLoop;

#---------------------------------------------------------
sub loadcollocInXPath {
    my $chemin=$montantF->get();
    my $path=$montantE->get();
    if ($chemin ne "") {
	if (!open(FILE, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	if ($path eq "") {
	    &mkPrintErreur("ERREUR : no XPath definition\n");
	    return;
	}
	if (!open(OUTFILE, ">MKC-tmp_collocInXPath.txt")) {
	    &mkPrintErreur("ERREUR : can't open MKC-tmp_collocInXPath.txt \n");
	    return;
	}
	use XML::XPath;
	use XML::XPath::XMLParser;	
	my $xpath = XML::XPath->new(filename => $chemin);
	my $nodeset = $xpath->find($path);	
	if ($nodeset->size) {
	    foreach my $node ($nodeset->get_nodelist) {
		print OUTFILE XML::XPath::XMLParser::as_string($node)."\n";
	    }
	}
	else {
	    print OUTFILE  "No nodes found\n";
	    &mkPrintErreur("ERREUR : No nodes found\n");
	    return;
	}
	close (OUTFILE);
	&makeCollocationsInXPathNodes;
#	system("perl makeCollocationsInXPathNodes.pl MKC-tmp_collocInXPath.txt");
	my $tmpfile="MKC-tmp_collocations.txt";
	my $msg="MKC-tmp_collocations.txt";
	&IncludedFileInWindow($tmpfile,$msg);
    }
}
#---------------------------------------------------------
sub helpcollocInXPath {
    my $msg ="Recherche de collocation pour tous les noeuds donns correspondant au chemin XPath donn dans un fichier donn.\n";
    $main->Dialog(
		  -title => "Help : ",
		  -text  => $msg
		)->Show();
}
#---------------------------------------------------------
sub  mkPrintErreur {
	my $msg = shift;
	$main->Dialog(
		 -title => "ERROR !",
		      -text  => $msg
		 )->Show();
}

#---------------------------------------------------------
sub  mkPrintMsgInfo {
    my $msg = shift;
    $main->Dialog(
		  -title => "Info : ",
		  -text  => $msg
		)->Show();
}
#---------------------------------------------------------
sub IncludedFileInWindow {
    my ($tmpfile,$msg) = @_;
    my $mkWindowForIncludingFile->destroy if Exists($mkWindowForIncludingFile);
    $mkWindowForIncludingFile = $main->Toplevel();
    my $w = $mkWindowForIncludingFile;
    $w->title("$msg");
    $w->iconname("$msg");
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_save = $w->Button(-text => "Save",
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);

    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');
    # Set up display styles
    my(@bold, @normal, $tags);
    if ($mkWindowForIncludingFile->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    $w_t->insert('0.0', '');
    $w_t->IncludeFile($tmpfile);
}

#---------------------------------------------------------
sub viderMontant {
    if (Exists($montantF)) {$montantF->delete(0, 'end')};
    if (Exists($montantE)) {$montantE->delete(0, 'end')};
    if (Exists($montantG)) {$montantG->delete(0, 'end')};
}

#---------------------------------------------------------
sub makeCollocationsInXPathNodes {
    if (!open(F,"MKC-tmp_collocInXPath.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_collocInXPath.txt\n");
	return;
    }
    if (!open(FIC2,">MKC-tmp_collocations.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_collocations.txt\n");
    return;
	}
    my $debug = 0; 
    my @offsets;
# Debug-Meldungen ein- oder ausschalten
    my $leftRight = 4; 
# immer je $leftRight Wrter nach links und nach rechts. Fenstergre ist somit $leftRight * 2 + 1
    my $begin = time();
    my $typeCnt  = 0;  
# hier werden die Types des Korpus gezhlt
### File Zeile fr Zeile einlesen ###

    my $lineCnt = 0;
    while(my $line = <F> ){
	next if(substr($line, 0, 2) eq "%%");
	print FIC2 "Processing line $lineCnt... (elapsed: ", (time() - $begin), "sec)\n" if( $lineCnt % 1000 == 0);
	$line =~ s/^\s+[0-9]+:\s+//;
	my @tokens = split( /\s+/, $line );
	### Schleife ber jeden Token im Satz ###
	for(my $i = 0; $i <= $#tokens; $i++){
	    dbg("$tokens[$i]\n");
	    ### Fenster, das rechten und linken Kontext eines jeden Tokens betrachtet ###
	    for(my $j = ($i - $leftRight); $j <= ($i + $leftRight); $j++ ){
		$j = 0 if( $j < 0 );
		last if( $j > $#tokens );
		dbg("\t" . $tokens[$j] . " (" . ($j - $i) . ")\n");
		registerType( $tokens[$j] );
		push(
		     @{		# als Array interpretierter ...
			 ${ $offsets[ $typesCollocations{ $tokens[$i] }]  }{$typesCollocations{ $tokens[$j] }} # ... Wert des doppelten Hashs
		 }
		,
		$j - $i 
		    )
		if($j - $i != 0);
	}
	dbg("\n");
    }
    $lineCnt++;	
    last if($lineCnt == 2000);
}
close F;

print FIC2 "Beginne Berechnung...";
print FIC2 "Abgelaufen bisher: ", ( time() - $begin ), " sec.\n";

### Errechnen und ausgeben: mean offset und standard deviation ###
my $token1Nr = 0;
foreach my $hashRef ( @offsets ){
    foreach my $token2Nr ( keys %{$hashRef} ){
	print FIC2 "$numbersCollocations[$token1Nr]\t$numbersCollocations[$token2Nr]\t\t";	
	my @offsetsForToken1AndToken2 = @{ ${ $offsets[$token1Nr] }{ $token2Nr } };
    dbg("( ");
    foreach(@offsetsForToken1AndToken2){
	dbg("$_ ");
    }
    dbg(") ");
    my $meanTmp = mean( @offsetsForToken1AndToken2 );
    $meanTmp = sprintf("%.3f", $meanTmp); # auf 3 Stellen runden
    my $devTmp = stdDev( \@offsetsForToken1AndToken2, $meanTmp );
    $devTmp = sprintf("%.3f", $devTmp) if(defined $devTmp);
    
    # Die Ergebnisse knnte man wieder speichern:
    #${$means{$token1Nr}}{$token2Nr} = $meanTmp;
    #${$stdDev{$token1Nr}}{$token2Nr} = $devTmp;
    
    my $cntTmp = $#offsetsForToken1AndToken2 + 1;
    print FIC2 "CNT = $cntTmp\t";
    print FIC2 "MEAN = $meanTmp";
    print FIC2 "\tDEV = $devTmp", (($cntTmp > 2 && $devTmp <= 1)?(" !!!"):(""))
	if( defined $devTmp );
    print FIC2 "\n";
}
$token1Nr++;
}
print FIC2 "Gesamtzeit: ", ( time() - $begin ), " sec.\n";
close(F);
close(FIC2);


#########################################################################
### mean offset (Mittlerer Abstand) ausrechnen
### Parameter: Einen Array, der alle Abweichungen enthlt, (-1, 3, 2, -2)
#########################################################################
sub mean{
	my @offsets = @_;
	my $sum = 0;
	foreach (@offsets){
		$sum += $_;		
	}
	return ($sum / (($#offsets > 0)?($#offsets + 1):(1)));
}

######################################################################
### standard deviation ausrechnen
### Parameter: Einen Array, der alle Abweichungen enthlt und die mean-offset-Zahl
######################################################################
sub stdDev{
	my ($offsetsRef, $meanOffset) = @_;
	my @offsets = @$offsetsRef;
	return undef if( $#offsets == 0 ); # nur ein Element
	my $stdDev = 0;
	foreach $offset (@offsets){
		$stdDev += (($offset - $meanOffset) * ($offset - $meanOffset));
	}
	return sqrt( $stdDev / $#offsets );
}

######################################################################
# Type neu in den Hash eintragen: Jeder Type bekommt 'ne eigene Nummer 
######################################################################
sub registerType{
	my $w = shift;
	unless(defined $typesCollocations{$w} ){
		$typesCollocations{$w} = $typeCnt++;
		push (@numbersCollocations, $w);
	}
}

###################################################################
### dbg() - Einfache Info-Messages ber den Programmablauf ausgeben
###################################################################
sub dbg{
    $debug && print shift; # Ausgabe nur, wenn $debug wahr.
}
}
