#! /usr/bin/perl 
use Tk;
use Tk::Dialog;
use Tk::DialogBox;


$mainconcatFile = MainWindow->new(-title=>'Concatnation de fichier');

my $frame1 = $mainconcatFile->Frame()->pack();
my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);

my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);

my $frame2 = $mainconcatFile->Frame()->pack();
my $frame3 = $mainconcatFile->Frame()->pack();

my $libelF = $frameG2->Label(-text=>'Chemin du rpertoire (input) :')->pack(-padx=>5);

my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
$montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
    ->pack(		-fill => 'x',
			-expand => 1);
$defil->pack(-fill => 'x',
	     -expand => 1);
$defil->configure(-command => [$montantF => 'xview']);

my $libelE = $frameG3->Label(-text=>'Chemin du rpertoire (output) :')->pack(-padx=>5);

my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");

$montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
    ->pack(		-fill => 'x',
			-expand => 1);
$defil2->pack(-fill => 'x',
	     -expand => 1);
$defil2->configure(-command => [$montantE => 'xview']);

my $raz = $frame2->Button(-text=>'RAZ', -command=>\&vider)->pack(-side=>'left', -padx=>20, -pady=>5);
my $calcul = $frame2->Button(-text=>'Concatnation', -command=>\&loadconcatxml)->pack(-side=>'right', -padx=>20, -pady=>5);
my $fin = $frame3->Button(-text=>'Exit', -command=>sub {$mainconcatFile->destroy()})->pack(-pady=>5);
MainLoop;



sub loadconcatxml
{
	my $chemin=$montantF->get();
	my $cheminout=$montantE->get();
	if ($chemin ne "") {
	    if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	    if (!opendir(DIR, $chemin)) {
		&mkPrintErreur("ERREUR : can't open $chemin: $!\n");
		return;
	    }  
	    if ($cheminout eq "") {
		$cheminout = $chemin."result-concatenation.xml";
	    }
	    else {
		if (!opendir(DIR2, $cheminout)) {
		    &mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		    return;
		} 
		if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
		$cheminout = $cheminout."result-concatenation.xml";
	    }
	    my @files = readdir(DIR);
	    closedir(DIR);

	    if (!open(TRACE, ">>$cheminout")) {
		    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier en sortie $cheminout  \n");
		    return;
		}	
	    print TRACE "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n";
	    print TRACE "<concatfile>\n";
	    my $filecount = 0;
	    foreach my $file (@files) {
		my $filecount++;
		next if $file =~ /^\.\.?$/;
		$file = $chemin.$file;
		print "I => ",$file,"\n";
		if (-f $file) {
		        if (!open(FILE, $file)) {
			    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier en lecture : $file \n");
			    return;
			}	
			print TRACE "\n<file name=\"$file\">\n";
			while (<FILE>) {
			    my $tmp=$_;
			    $tmp=~s/</&lt;/g;
			    $tmp=~s/>/&gt;/g;
			    $tmp=~s/\@/_AROBASE_/g;
			    print TRACE $tmp;
			}
			close (FILE);
			print TRACE "</file>\n";
		    }
	    }
	    print TRACE "</concatfile>\n";
	    close (TRACE);
	    &mkPrintMsgInfo("Concatnation termine dans : $cheminout \n");
	}
	else
	{
	&mkPrintErreur("ERREUR : impossible d\'accder au rpertoire $chemin\n");
	return;
	}




}

sub vider {
	$montantF->delete(0, 'end');
	$montantE->delete(0, 'end');
    }

sub  mkPrintMsgInfo {
    my $msg = shift;
    $mainconcatFile->Dialog(
		  -title => "Info : ",
		  -text  => $msg
		)->Show();
}

