##############################################################################
#AUTHORS: 	Fleury Serge
#VERSION: 	1.0.2
#email:		serge.fleury@univ-paris3.fr
#url:		http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/mkcorpusProject.htm
#date:		June/2002
#FILE:
#    This file is part of MKCorpus.
##############################################################################
use Tk;
use Tk::Dialog;
use Tk::DialogBox;
use Tk::TextUndo;
use XML::Writer;
use IO::Handle;
use IO::Seekable;
use IO::File;
use IO::Pipe;
use IO::Socket;
use IO::Dir;
use Tk::Photo;

$main = MainWindow->new(-title=>'DIR2XML :');
$main->geometry("400x300+100+100");
    my $imgLogo=$main->Photo(-file=>"logo-mkc.gif");
    my $lblLogo=$main->Button(-image=>$imgLogo)->place(-y=>0,-x=>0,-width=>400,-height=>300);
    my $frame1 = $main->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
    my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);
    my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);
    my $frame2 = $main->Frame()->pack();
    my $frame3 = $main->Frame()->pack();
    my $libelF = $frameG2->Label(-text=>'Chemin du rpertoire (input) :')->pack(-padx=>5);
    my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
    $montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil->pack(-fill => 'x',
		 -expand => 1);
    $defil->configure(-command => [$montantF => 'xview']);
    my $libelE = $frameG3->Label(-text=>'Chemin du rpertoire (output) :')->pack(-padx=>5);
    my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");
    $montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil2->pack(-fill => 'x',
		  -expand => 1);
    $defil2->configure(-command => [$montantE => 'xview']);
    my $raz = $main->Button(-text=>'RAZ', -activeforeground=>"blue",-relief=>'flat', -command=>\&viderMontant)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $calcul = $main->Button(-text=>'DIR2XML', -activeforeground=>"blue",-relief=>'flat', -command=>\&loaddirectory2xml)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $help = $main->Button(-text=>'Help', -activeforeground=>"blue",-relief=>'flat', -command=>\&helpdirectory2xml)->pack(-side=>'right', -padx=>5, -pady=>5);
    my $fin = $main->Button(-text=>'Exit', -activeforeground=>"blue",-relief=>'flat', -command=>sub {$main->destroy()})->pack(-side=>'right', -padx=>5, -pady=>5);
    my $calcul2 = $main->Button(-width=>40, -text=>'DIR2XML-withContent',-activeforeground=>"blue",-relief=>'flat',  -command=>\&loaddirectory2xml2)->pack(-side=>'right',  -fill=>'x', -expand =>1);

MainLoop;


#---------------------------------------------------------
sub helpdirectory2xml {
    my $msg ="1. Option DIR2XML : conversion d'une arborescence donne au format XML\n\n2.Option DIR2XML-withContent : conversion d'une arborescence donne au format XML avec intgration du contenu des fichiers lus dans l'arborescence.\n";
    $main->Dialog(
		  -title => "Help : ",
		  -text  => $msg
		)->Show();
}
#---------------------------------------------------------
sub loaddirectory2xml {
    use XML::Writer;
    my $chemin=$montantF->get();
    my $cheminout=$montantE->get();
    if ($chemin ne "") {
	if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	if (!opendir(DIR, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	closedir(DIR);
	if ($cheminout eq "") {
		$cheminout = $chemin;
	    }
	else {
	    if (!opendir(DIR2, $cheminout)) {
		&mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		return;
	    } 
	    if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
	}
	my $filecount=0;
	my $fileOut = $cheminout.""."MKC-directory2xml.xml";
	my $output = new IO::File(">$fileOut");
	$directory2xmlrecursewriter = new XML::Writer( DATA_MODE => 'true', DATA_INDENT => 2, OUTPUT => $output);
	$directory2xmlrecursewriter->xmlDecl("ISO-8859-1");
	&directory2xmlrecurse($chemin);
	$output->close();

	my $tmpfile=$fileOut ;
	my $msg="Dir2XML Result" ;
	&IncludedFileInWindow($tmpfile,$msg);


	sub directory2xmlrecurse {
	    my $path = shift(@_);
	    return unless (-e $path);
	    if (-d $path) {
		$directory2xmlrecursewriter->startTag('directory', 'name' => $path);
		my @content=();
		opendir(DIR, $path) or die "can't open $path: $!\n";
		while (my $item = readdir(DIR)) {
		    next if ($item =~ /^\.\.?$/);
		    push (@content, $item);
		}
		closedir(DIR);
		foreach my $file (@content) {
		    $file = $path."/".$file;
		    &directory2xmlrecurse($file);	#recurse!
		}
		$directory2xmlrecursewriter->endTag('directory');
	    }
	    else {
		if ($path!~/MKC-directory2xml\.xml/) {
		    $filecount++;
		    $directory2xmlrecursewriter->startTag('file', 'name' => $path, 'number' => $filecount);
		    $directory2xmlrecursewriter->startTag('content');
		    $directory2xmlrecursewriter->endTag('content');
		    $directory2xmlrecursewriter->endTag('file');
		}
	    }
	}
}
}
#---------------------------------------------------------
sub loaddirectory2xml2 {
    use XML::Writer;
    my $chemin=$montantF->get();
    my $cheminout=$montantE->get();
    if ($chemin ne "") {
	if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	if (!opendir(DIR, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	closedir(DIR);
	if ($cheminout eq "") {
		$cheminout = $chemin;
	    }
	else {
	    if (!opendir(DIR2, $cheminout)) {
		&mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		return;
	    } 
	    if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
	}
	my $filecount=0;
	my $fileOut = $cheminout.""."MKC-directory2xml-content.xml";
	my $output = new IO::File(">$fileOut");
	$directory2xmlrecursewriter = new XML::Writer( DATA_MODE => 'true', DATA_INDENT => 2, OUTPUT => $output);
	$directory2xmlrecursewriter->xmlDecl("ISO-8859-1");
	&directory2xmlrecurse2($chemin);
	$output->close();
	my $tmpfile=$fileOut ;
	my $msg="Dir2XML Result" ;
	&IncludedFileInWindow($tmpfile,$msg);

	sub directory2xmlrecurse2 {
	    my $path = shift(@_);
	    return unless (-e $path);
	    if (-d $path) {
		$directory2xmlrecursewriter->startTag('directory', 'name' => $path);
		my @content=();
		opendir(DIR, $path) or die "can't open $path: $!\n";
		while (my $item = readdir(DIR)) {
		    next if ($item =~ /^\.\.?$/);
		    push (@content, $item);
		}
		closedir(DIR);
		foreach my $file (@content) {
		    $file = $path."/".$file;
		    &directory2xmlrecurse2($file);	#recurse!
		}
		$directory2xmlrecursewriter->endTag('directory');
	    }
	    else {
		if ($path!~/MKC-directory2xml-content\.xml/) {
		    $filecount++;
		    $directory2xmlrecursewriter->startTag('file', 'name' => $path, 'number' => $filecount);
		    $directory2xmlrecursewriter->startTag('content');
		    if (!open(TMPFILE,$path)) {
#		    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$path'\n");
#		    return;
			my $line = "ERREUR : Impossible d\'ouvrir $path";
			$directory2xmlrecursewriter->characters($line);
		    }
		    while (my $line=<TMPFILE>) {
			$directory2xmlrecursewriter->characters($line);
		    }
		    close(TMPFILE);
		    $directory2xmlrecursewriter->endTag('content');
		    $directory2xmlrecursewriter->endTag('file');
		}
	    }
	}
}
}
#---------------------------------------------------------
sub  mkPrintErreur {
	my $msg = shift;
	$main->Dialog(
		 -title => "ERROR !",
		      -text  => $msg
		 )->Show();
}

#---------------------------------------------------------
sub  mkPrintMsgInfo {
    my $msg = shift;
    $main->Dialog(
		  -title => "Info : ",
		  -text  => $msg
		)->Show();
}
#---------------------------------------------------------
sub IncludedFileInWindow {
    my ($tmpfile,$msg) = @_;
    my $mkWindowForIncludingFile->destroy if Exists($mkWindowForIncludingFile);
    $mkWindowForIncludingFile = $main->Toplevel();
    my $w = $mkWindowForIncludingFile;
    $w->title("$msg");
    $w->iconname("$msg");
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_save = $w->Button(-text => "Save",
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);

    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');
    # Set up display styles
    my(@bold, @normal, $tags);
    if ($mkWindowForIncludingFile->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    $w_t->insert('0.0', '');
    $w_t->IncludeFile($tmpfile);
}

#---------------------------------------------------------
sub viderMontant {
    if (Exists($montantF)) {$montantF->delete(0, 'end')};
    if (Exists($montantE)) {$montantE->delete(0, 'end')};
    if (Exists($montantG)) {$montantG->delete(0, 'end')};
}
