##############################################################################
#AUTHORS: 	Fleury Serge
#VERSION: 	1.0.2
#email:		serge.fleury@univ-paris3.fr
#url:		http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/mkcorpusProject.htm
#date:		June/2002
#FILE:
#    This file is part of MKCorpus.
##############################################################################
use Tk;
use Tk::Dialog;
use Tk::DialogBox;
use Tk::TextUndo;
use Tk::Photo;



$main = MainWindow->new(-title=>'Select File (random) :');
$main->geometry("400x300+100+100");
my $imgLogo=$main->Photo(-file=>"logo-mkc.gif");
my $lblLogo=$main->Button(-image=>$imgLogo)->place(-y=>0,-x=>0,-width=>400,-height=>300);
my $frame1 = $main->Frame()->pack(-side=>'bottom', -pady=>5);
my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
my $frameH1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);
my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);
my $frameG4 = $frameH1->Frame()->pack(-side=>'left', -pady=>5);
my $frameD4 = $frameH1->Frame()->pack(-side=>'right', -pady=>5);
my $frame2 = $main->Frame()->pack();
my $frame3 = $main->Frame()->pack();

my $libelF = $frameG2->Label(-text=>'Directory (input) :')->pack(-padx=>5);
my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
$montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
    ->pack(		-fill => 'x',
			-expand => 1);
$defil->pack(-fill => 'x',
	     -expand => 1);
$defil->configure(-command => [$montantF => 'xview']);

my $libelE = $frameG3->Label(-text=>'Directory (output) :')->pack(-padx=>5);
my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");
$montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
    ->pack(		-fill => 'x',
			-expand => 1);
$defil2->pack(-fill => 'x',
	      -expand => 1);
$defil2->configure(-command => [$montantE => 'xview']);

my $libelG = $frameG4->Label(-text=>'Nombre MAX de fichiers :')->pack(-padx=>5);
my $defil3 = $frameD4-> Scrollbar(-orient => "horizontal");
$montantG = $frameD4->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil3] )
    ->pack(		-fill => 'x',
			-expand => 1);
$defil3->pack(-fill => 'x',
	      -expand => 1);
$defil3->configure(-command => [$montantG => 'xview']);


my $raz = $main->Button(-text=>'RAZ', -activeforeground=>"blue",-relief=>'flat', -command=>\&viderMontant)->pack(-side=>'left', -padx=>5, -pady=>5);

my $calcul = $main->Button(-text=>'Copy', -activeforeground=>"blue",-relief=>'flat', -command=>\&loadrandSelectFile)->pack(-side=>'left', -padx=>5, -pady=>5);
my $help = $main->Button(-text=>'Help', -activeforeground=>"blue",-relief=>'flat', -command=>\&help_randSelectFile)->pack(-side=>'right', -padx=>5, -pady=>5);
my $fin = $main->Button(-text=>'Exit', -activeforeground=>"blue",-relief=>'flat', -command=>sub {$main->destroy()})->pack(-side=>'right', -padx=>5, -pady=>5);

MainLoop;


sub loadrandSelectFile {
    my $nombreFichiers=0;
    my $chemin=$montantF->get();
    my $cheminout=$montantE->get();
    if ($chemin ne "") {
	if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	$chemin=~s/\\/\//g;
	if (!opendir(DIR, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	closedir(DIR);
    }
    else {
	&mkPrintErreur("ERREUR : input DIR requested\n");
	return;
    }
    if ($cheminout ne "") {
	if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
	$cheminout=~s/\\/\//g;
	if (!opendir(DIR, $cheminout)) {
	    &mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
	    return;
	}
	closedir(DIR);
    }
	else {
	    &mkPrintErreur("ERREUR : output DIR requested\n");
	    return;
	}
    my $nombreFichiersMaximum=$montantG->get();
    my $seuilExtractionAleatoire = 0.4;
    &copieFichiers($chemin);
#-------
    sub copieFichiers {
	if ($nombreFichiers > $nombreFichiersMaximum) {return;};
	my $path = shift(@_);
	return unless (-e $path);
	if (-d $path) {
	    my @content=();
	    opendir(DIR, $path) or die "can't open $path: $!\n";
	    while (my $item = readdir(DIR)) {
		next if ($item =~ /^\.\.?$/);
		push (@content, $item);
	    }
	    closedir(DIR);
	    foreach my $file (@content) {
		$file = $path."/".$file;
		&copieFichiers($file);	#recurse!
	    }
	}
	else {
	    next if $path =~ /^\.\.?$/;
	    my $nombreAleatoire=rand;
	    print "$nombreAleatoire = nombreAleatoire --- $nombreFichiers =  nombreFichiers --- $nombreFichiersMaximum = nombreFichiersMaximum\n";
	    if (($nombreAleatoire <= $seuilExtractionAleatoire) && ($nombreFichiers < $nombreFichiersMaximum)) {
		$path=~/\/([^\/]+)$/;
		my $pathout;
		if ($1 ne "") {
		    $pathout="MKC-".$nombreFichiers."-".$1;
		}
		else {
		    $pathout="MKC-".$nombreFichiers."-"."unknownOriginalNameFile";
		}
		system("cp $path $cheminout/$pathout");
		$nombreFichiers++;
	    }
	}
    }
}
#---------------------------------------------------------
sub help_randSelectFile {
    my $msg ="Format d\'entree : un nombre important de fichiers dans un dossier, a extraire de maniere aleatoire. Format de Sortie : le nombre de fichiers passe en argument extraits aleatoirement dans le dossier de sortie out/.\n";
    $main->Dialog(
		  -title => "Help : ",
		  -text  => $msg
		)->Show();

}
#---------------------------------------------------------
sub  mkPrintErreur {
	my $msg = shift;
	$main->Dialog(
		 -title => "ERROR !",
		      -text  => $msg
		 )->Show();
}

#---------------------------------------------------------
sub  mkPrintMsgInfo {
    my $msg = shift;
    $main->Dialog(
		  -title => "Info : ",
		  -text  => $msg
		)->Show();
}
#---------------------------------------------------------
sub IncludedFileInWindow {
    my ($tmpfile,$msg) = @_;
    my $mkWindowForIncludingFile->destroy if Exists($mkWindowForIncludingFile);
    $mkWindowForIncludingFile = $main->Toplevel();
    my $w = $mkWindowForIncludingFile;
    $w->title("$msg");
    $w->iconname("$msg");
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_save = $w->Button(-text => "Save",
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);

    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');
    # Set up display styles
    my(@bold, @normal, $tags);
    if ($mkWindowForIncludingFile->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    $w_t->insert('0.0', '');
    $w_t->IncludeFile($tmpfile);
}

#---------------------------------------------------------
sub viderMontant {
    if (Exists($montantF)) {$montantF->delete(0, 'end')};
    if (Exists($montantE)) {$montantE->delete(0, 'end')};
    if (Exists($montantG)) {$montantG->delete(0, 'end')};
}
